<?php

// QuickTeam 2.5 build:20110323

// CONSTRAINT:
// users can be outside section (i.e. new user not yet in section)
// users without section are stored in the garbage collector (section 0)

/*
 * CLASS cSection
 *
 * constructor cSection: argument can be null, a section id, a section arr, a cSection object
 * function MakeFromArray: used by the constructor
 *
 */

class cSection extends aQTcontainer implements IOptions,IStats
{

// --------

public $name;      // Section name (translation)
public $vorder = 255;
public $forder;
public $modid = 1;
public $modname = '(Admin)';
public $options='';   // Several stats (no used)
public $stats='';   // Several stats (no used)
public $members = 0;
public $membersZ = 0;

// options
public $d_order='';  // Teams member default sort order (not used)
public $d_logo='';   // Section picture named s_x.gif/.jpeg/.jpg/.png (where x is the section id)

// not used (version 14)
public $template='T';      // 'T'=table, 'P'=preview, 'C'=compactlist;
public $ontop='0';   // status members to be on top (0=none)

// --------

function __construct($aSection=null)
{
  if ( isset($aSection) )
  {
    if ( is_int($aSection) )
    {
      if ( $aSection<0 ) die('Wrong id in cSection');
      global $oDB;
      $oDB->Query('SELECT * FROM '.TABSECTION.' WHERE id='.$aSection);
      $row = $oDB->Getrow();
      if ( $row===False ) die('No section '.$aSection);
      $this->MakeFromArray($row);
    }
    elseif ( is_array($aSection) )
    {
      $this->MakeFromArray($aSection);
    }
    else
    {
      die('Invalid constructor parametre #1 for the class cSection');
    }
  }
  // Read options/stats

  $this->ReadOptions();
  $this->ReadStats();

}

// --------

private function MakeFromArray($arr)
{
  if ( !is_array($arr) ) die('Invalid argument for cSection->MakeFromArray');
  foreach ($arr as $strKey => $oValue) {
  switch ($strKey) {
    case 'domainid': $this->parentid   = intval($oValue); break;
    case 'id':       $this->id      = intval($oValue); break;
    case 'title':    $this->title = $oValue; break;
    case 'type':     $this->type    = intval($oValue); break;
    case 'status':   $this->status  = intval($oValue); break;
    case 'vorder':   $this->vorder  = intval($oValue); break;
    case 'forder':   $this->forder  = $oValue; if ( empty($this->forder) ) $this->forder = 'status_i;fullname;phones;emails;picture'; break;
    case 'modid':    $this->modid   = intval($oValue); if ( $this->modid<1 ) $this->modid=1; break;
    case 'modname':  $this->modname = $oValue; break;
    case 'stats':    $this->stats   = $oValue; break;
    case 'options':  $this->options = $oValue; break;
    // not used (version 14)
    case 'template': $this->template = $oValue; break;
    case 'ontop':    $this->ontop    = $oValue; break;
  }}
  $this->name = ObjTrans('sec','s'.$this->id,$this->title);
  $this->descr = ObjTrans('secdesc','s'.$this->id,false);
}

// --------

public function ShowInfo($strClassImage='',$strClassName='',$strClassDesc='',$strPictureUrl='',$qte_root='')
{
  $str = (empty($this->d_logo) ? '' : AsImg($qte_root.'document/section/'.$this->d_logo,'logo',$this->name,$strClassImage,'',$strPictureUrl));
  if ( !is_null($strClassName) ) $str .= '<p class="'.$strClassName.'">'.$this->name.'</p>';
  if ( !is_null($strClassDesc) ) $str .= '<p class="'.$strClassDesc.'">'.$this->descr.'</p>';
  if ( ! empty($str) ) echo $str; 
}

// --------
// aQTcontainer implementations
// --------

public static function Create($title,$parentid)
{
  if ( $parentid<0 ) die('cSection->Create: Cannot create section without domainid');
  
  global $oDB;
  $id = $oDB->Nextid(TABSECTION);
  $oDB->Query( 'INSERT INTO '.TABSECTION.' (domainid,id,title,type,status,stats,options,vorder,forder,modid,modname,template,ontop) VALUES ('.$parentid.','.$id.',"'.addslashes($title).'","0","0","members=0","logo=0",0,NULL,0,"Admin","T","0")' );
  if ( isset($_SESSION[QT]['sys_sections']) ) unset($_SESSION[QT]['sys_sections']);
  return $id;
}

public static function Drop($id)
{
  // Warning: if required use MoveItems() before Drop()
  if ( $id<1 ) die('cSection->Drop: Cannot delete domain 0');  
  
  global $oDB;
  $oDB->Query('DELETE FROM '.TABDOMAIN.' WHERE id='.$id);
  cVIP::LangDel('domain','d'.$id);
  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
}

public static function MoveItems($id,$destination)
{
  if ( $id<0 || $destination<0 ) die('cSection->MoveItems: source and destination cannot be <0');
  if ( $id==$destination ) die('cSection->MoveItems: source and destination are the same');
  
  global $oDB;
  $oDB->Query('UPDATE '.TABS2U." SET sid=$destination WHERE sid=$id");
}

public static function CountItems($id,$status)
{
  // Count Users in Section $id. Use -1 to count users through all sections
  global $oDB;
  if ( $id<0 )
  {
    $oDB->Query( 'SELECT count(*) as countid FROM '.TABUSER.(isset($status) ? ' WHERE status="'.$status.'"' : '') );
  }
  else
  {
    if ( isset($status) )
    {
      $oDB->Query( 'SELECT count(*) as countid FROM '.TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid=u.id WHERE l.sid='.$id.' AND u.status="'.$status.'"' );
    }
    else
    {
      $oDB->Query( 'SELECT count(*) as countid FROM '.TABS2U.' WHERE sid='.$id );
    }
  }
  $row = $oDB->Getrow();
  return (int)$row['countid'];
}

// --------
// IOptions, IStats implementations
// --------

public function ChangeOption($strKey,$strValue)
{
  QTargs('cSection->ChangeOption',array($strKey,$strValue));
  if ( $strKey==='' ) die ('cSection->ChangeOption: Missing key'); // $strKey can be ''

  $arr = QTarradd(QTexplode($this->options),$strKey,$strValue);
  $this->options = QTimplode($arr);
  $this->WriteOptions();
  return $arr;
}

public function ReadOptions()
{
  $arr = QTexplode($this->options);
  if ( isset($arr['order']) ) $this->d_order = $arr['order'];
  if ( isset($arr['logo']) ) $this->d_logo = $arr['logo']; 
  return $arr;
}

public function WriteOptions()
{
  global $oDB;
  $oDB->Query('UPDATE '.TABSECTION.' SET options="'.$this->options.'" WHERE id='.$this->id);
}

public function ChangeStat($strKey,$strValue)
{
  QTargs('cSection->ChangeStat',array($strKey,$strValue));
  if ( $strKey==='' ) die ('cSection->ChangeStat: Missing key'); // $strKey can be ''

  $arr = QTarradd(QTexplode($this->stats),$strKey,$strValue);
  $this->stats = QTimplode($arr);
  $this->WriteOptions();
  return $arr;
}

public function ReadStats()
{
  $arr = ReadValues($this->stats);
  if ( isset($arr['members']) ) $this->members = intval($arr['members']);
  if ( isset($arr['membersZ']) ) $this->membersZ = intval($arr['membersZ']);
  return $arr;
}

public function WriteStats()
{
  global $oDB;
  $oDB->Query('UPDATE '.TABSECTION.' SET stats="'.$this->stats.'" WHERE id='.$this->id);
}

// --------

}
