<?php

// QuickTeam 2.5 build:20110323

class cUser
{

// --------

public $id = -1;
public $username = ''; // this is the login BUT also the main displayed name. It's recommended to use the fullname (John Smith)
public $pwd = '';
public $role = 'V';
public $type = '';
public $status = 'Z';   // status must exist !
public $coppa = '0'; // is children (0=No, 1=Yes with parent agree, 2=Yes without parent agree)

public $title = '';    // M. Mr, Mme ...
public $firstname = '';
public $midname = '';
public $lastname = '';
public $alias = '';
public $fullname = ''; // computed info
public $birthdate = '0';
public $age = 0;      // computed info
public $nationality = '';
public $sexe = '';
public $picture = '';
public $secret_q = '';
public $secret_a = '';

public $address = '';
public $phones = '';
public $emails = '';
public $www = '';
public $privacy = '';
public $descr = '';
public $firstdate = '0';

public $teamid1 = '';
public $teamid2 = '';
public $teamrole1 = '';
public $teamrole2 = '';
public $teamdate1 = '0';
public $teamdate2 = '0';
public $teamvalue1 = '';
public $teamvalue2 = '';
public $teamflag1 = '';
public $teamflag2 = '';

public $x;
public $y;
public $z;

// --------
// attention: sqlite can return fieldname including the prefix alias (p.id)

function __construct($aUser=null,$bPrivate=false)
{
  if ( isset($aUser) )
  {
    if ( is_int($aUser) )
    {
      if ( $aUser<0 ) die('Wrong id in cUser');
      global $oDB;
      $oDB->Query('SELECT * FROM '.TABUSER.' WHERE id='.$aUser);
      $row = $oDB->Getrow();
      if ( $row===False ) die('No user '.$aUser);
      $this->MakeFromArray($row,$bPrivate);
    }
    elseif ( is_array($aUser) )
    {
      $this->MakeFromArray($aUser,$bPrivate);
    }
    else
    {
      die('Invalid constructor parametre #1 for the class cUser');
    }
  }

  // computed information
  if ( !empty($this->birthdate) ) $this->SetAge();
  $this->SetFullname();
}

// --------

public function Create($intSection=-1)
{
  $oDB->Query( 'INSERT INTO '.TABUSER.' (id,role,username,lastname,pwd,emails,children,status,firstdate) VALUES ('.$id.',"U","'.htmlspecialchars($strTitle,ENT_QUOTES).'","'.htmlspecialchars($strTitle,ENT_QUOTES).'","'.sha1($strNewpwd).'","'.$strMail.'","0","'.$_POST['status'].'","'.date('Ymd').'")' );
}

// --------

private function MakeFromArray($arr,$bPrivate=false)
{
  if ( !is_array($arr) ) die('Invalid argument for cUser->MakeFromArray');
  foreach ($arr as $strKey => $oValue)
  {
    if  ( !is_null($oValue) ) {
    switch ($strKey) {
    case 'id':         $this->id         = intval($oValue); break;
    case 'username':   $this->username   = $oValue; break;
    case 'pwd':        $this->pwd        = $oValue; break;
    case 'role':       $this->role       = $oValue; break;
    case 'type':       $this->type       = $oValue; break;
    case 'status':     $this->status     = $oValue; break;
    case 'children':   $this->coppa      = intval($oValue); break;
    case 'title':      $this->title      = $oValue; break;
    case 'firstname':  $this->firstname  = $oValue; break;
    case 'midname':    $this->midname    = $oValue; break;
    case 'lastname':   $this->lastname   = $oValue; break;
    case 'alias':      $this->alias      = $oValue; break;     
    case 'birthdate':  $this->birthdate  = $oValue; break;
    case 'nationality':$this->nationality= $oValue; break;
    case 'sexe':       $this->sexe       = $oValue; break;
    case 'picture':    $this->picture    = $oValue; break;
    case 'secret_q':   $this->secret_q   = $oValue; break;
    case 'secret_a':   $this->secret_a   = $oValue; break;
    case 'address':    $this->address    = $oValue; break;
    case 'phones':     $this->phones     = $oValue; break;
    case 'emails':     $this->emails     = $oValue; break;
    case 'www':        $this->www        = $oValue; break;
    case 'privacy':    $this->privacy    = $oValue; break;
    case 'descr':      $this->descr      = $oValue; break;
    case 'firstdate':  $this->firstdate  = $oValue; break;
    case 'teamid1':    $this->teamid1    = $oValue; break;
    case 'teamid2':    $this->teamid2    = $oValue; break;
    case 'teamrole1':  $this->teamrole1  = $oValue; break;
    case 'teamrole2':  $this->teamrole2  = $oValue; break;
    case 'teamdate1':  $this->teamdate1  = $oValue; break;
    case 'teamdate2':  $this->teamdate2  = $oValue; break;
    case 'teamvalue1': $this->teamvalue1 = $oValue; break;
    case 'teamvalue2': $this->teamvalue2 = $oValue; break;
    case 'teamflag1':  $this->teamflag1  = $oValue; break;
    case 'teamflag2':  $this->teamflag2  = $oValue; break;
    case 'y': $this->y = $oValue; break;
    case 'x': $this->x = $oValue; break;
    case 'z': $this->z = $oValue; break;
    }}
  }
  // private information
  if ( $bPrivate && !empty($this->privacy) ) $this->SetPrivate();
}

// --------

function SetPrivate()
{
  global $oVIP;
  foreach (array('address','phones','emails','descr') as $strKey)
  {
  if ( $oVIP->IsPrivate($this->privacy,$strKey,$this->id) ) $this->$strKey='';  
  }
  // coordinates
  if ( $oVIP->IsPrivate($this->privacy,'coord',$this->id) ) { $this->x=null; $this->y=null; }
}

// --------

function SetAge()
{
  if ( isset($_SESSION[QT]['fields_u']) ) {
  if ( strstr($_SESSION[QT]['fields_u'],'birthdate') ) {
  if ( !empty($this->birthdate) ) {
  if ( isset($_SESSION[QT]['fields_c']) ) {
  if ( strstr($_SESSION[QT]['fields_c'],'age') ) {
    $this->age = date('Y') - intval(substr(strval($this->birthdate),0,4)) - 1;
    if ( date('md') >= intval(substr(strval($this->birthdate),4,4)) ) $this->age++;
    if ( $this->age<0 ) $this->age=0;
  }}}}}
}

// --------

function SetFullname()
{
  $strDisabled='';
  if ( isset($_SESSION[QT]['fields_u']) )
  {
    if ( !strstr($_SESSION[QT]['fields_u'],'title') ) $strDisabled .= 'title,';
    if ( !strstr($_SESSION[QT]['fields_u'],'firstname') ) $strDisabled .= 'firstname,';
    if ( !strstr($_SESSION[QT]['fields_u'],'lastname') ) $strDisabled .= 'lastname,';
    if ( !strstr($_SESSION[QT]['fields_u'],'midname') ) $strDisabled .= 'midname,';
    if ( !strstr($_SESSION[QT]['fields_u'],'alias') ) $strDisabled .= 'alias,';
  }
  $this->fullname = $this->username;
  if ( !empty($this->lastname) && !strstr($strDisabled,'lastname') )
  { 
      $this->fullname = $this->lastname;
      if ( !empty($this->midname) && !strstr($strDisabled,'midname') ) $this->fullname = $this->midname.' '.$this->fullname;
      if ( !empty($this->firstname) && !strstr($strDisabled,'firstname') ) $this->fullname = $this->firstname.' '.$this->fullname;
      if ( !empty($this->title) && !strstr($strDisabled,'title') ) $this->fullname = $this->title.' '.$this->fullname;
      if ( !empty($this->alias) && !strstr($strDisabled,'alias') ) $this->fullname .= ' "'.$this->alias.'"';
  }
  if ( empty($this->lastname) ) $this->lastname = $this->username;
}

// --------

function Delete($bStat=true) 
{
  QTargs('cUser->Delete',array($bStat),array('boo'));
  if ( $this->id<2 ) die('cUser->Delete: Wrong id cannot delete user 0 and 1');
  
  global $oDB;
  $oDB->Query('UPDATE '.TABSECTION.' SET modid=1, modname="Administrator" WHERE modid='.$this->id);
  $oDB->Query('DELETE FROM '.TABS2U.' WHERE userid='.$this->id);
  $oDB->Query('DELETE FROM '.TABUSER.' WHERE id='.$this->id);
  $oDB->Query('DELETE FROM '.TABCHILD.' WHERE id='.$this->id);
  $oDB->Query('DELETE FROM '.TABINDEX.' WHERE userid='.$this->id);

  // remove images

  if ( !empty($this->picture) ) {
  if ( file_exists(QTE_DIR_PIC.$this->picture) ) {
    unlink(QTE_DIR_PIC.$this->picture);
  }}
  
  // update stats

  if ( $bStat && isset($_SESSION[QT]['sys_sections']) )
  {
  foreach($_SESSION[QT]['sys_sections'] as $intId=>$arr) UpdateSectionStats($intId);
  }
}

// --------

function InSection($intSection=-1,$strAction='add',$id=null)
{
  if ( !is_numeric($intSection) ) die('Wrong id in user->InSection');
  if ( !is_string($strAction) ) die('Wrong id in user->InSection');
  if ( $intSection<0 ) die('Wrong id in user->InSection');
  if ( !isset($id) ) $id = $this->id;
  if ( $id<0)  die('Wrong id in user->InSection');
  
  global $oDB;
  switch ($strAction)
  {
  case 'add': 
    $oDB->Query('SELECT count(*) as countid FROM '.TABS2U.' WHERE sid='.$intSection.' AND userid='.$id);
    $row = $oDB->Getrow();
    if ( $row['countid']==0 )
    {
    $oDB->Query('INSERT INTO '.TABS2U.' (sid,userid,issuedate) VALUES ('.$intSection.','.$id.',"'.date('Ymd').'")');
    }
    else
    {
    return false;
    }
    break;
  case 'rem':
    $oDB->Query('DELETE FROM '.TABS2U.' WHERE sid='.$intSection.' AND userid='.$id);
      // add in the garbage collector if necessary
      if ( CountMembership($id)==0 ) $oDB->Query('INSERT INTO '.TABS2U.' (sid,userid,issuedate) VALUES (0,'.$id.',"'.date('Ymd').'")');
    break;
  }
  return true;
}

// --------

function GetKeywords($arrFields)
{
  $arrKeys = array();
  foreach ($arrFields as $strField)
  {
    $arrKeys[$strField] = array();
    $str = strtoupper(strip_tags($this->$strField));
    $str = QTconv($str,'-4');
    $str = strtr($str,'(){}+-=;,:.@/?!"','                ');
    $str = str_replace('\'',' ',$str);
    $str = str_replace('  ',' ',$str);
    $arr = explode(' ',$str);
    foreach ($arr as $str)
    {
     if ( strlen($str)>=2 ) $arrKeys[$strField][] = $str;
    }
    $arrKeys[$strField] = array_unique($arrKeys[$strField]);
  }
  return $arrKeys;
}

// --------

function SaveKeywords($arrKeys)
{
  global $oDB;
  $arrFields = array_keys($arrKeys);
  foreach ($arrFields as $strField)
  {
    $oDB->query('DELETE FROM '.TABINDEX.' WHERE userid='.$this->id.' AND ufield="'.$strField.'"');
    foreach ($arrKeys[$strField] as $strValue)
    {
    $oDB->query('INSERT INTO '.TABINDEX.' (userid,ufield,ukey) VALUES ('.$this->id.',"'.$strField.'","'.$strValue.'")');
    }
  }
}

// --------

}
