<?php



// QuickTeam 2.5 build:20110323



class cFLD

{



public $on = false;

public $id = '';     // field key (can be "emails_i")

public $uid = '';

public $sort = false;// default sort order (ASC,DESC,FALSE)

public $name = '';   // field translation

public $format = ''; // field format

public $class_th = '';

public $style_th = '';

public $class_td = '';

public $style_td = '';

public $class_dynamic = false; // To use this, define an array('formula-%s','field',array-of-classes). Note: keys of the array-of-classes must be strings

public $style_dynamic = false; // To use this, define an array('formula-%s','field',array-of-styles). Note: keys of the array-of-styles must be strings



function __construct($id,$name,$class_th='',$style_th='',$class_td='',$style_td='',$sort=false)

{

  $this->id = $id;

  $this->uid = ( substr($id,-2,2)=='_i' ? substr($id,0,-2) : $id );

  $this->on = in_array($this->uid,explode(',',$_SESSION[QT]['fields_c'].','.$_SESSION[QT]['fields_u'].','.$_SESSION[QT]['fields_t'].',coord'));

  $this->name = $name;

  $this->class_th = $class_th;

  $this->style_th = $style_th;

  $this->class_td = $class_td;

  $this->style_td = $style_td;

  $this->sort = $sort;

  if ( $this->on )

  {

  $this->name = ObjTrans('field',$this->uid);

  $this->format = ObjTrans('ffield',$this->uid,'');

  }

}



function AddStyleDynamic($arr)

{

  // Change $this->style_td to add a dynamic style based on the parameters in $this->style_dynamic and according to the values in $arr

  if ( !is_array($arr) ) return; // row not defined

  if ( count($arr)==0 ) return; // row not defined

  if ( !is_array($this->style_dynamic) ) return; // formula not defined

  if ( count($this->style_dynamic)!=3 ) return; // formula not defined

  if ( !is_string($this->style_dynamic[0]) ) return; // formula not defined

  if ( !is_string($this->style_dynamic[1]) ) return; // formula not defined

  if ( !is_array($this->style_dynamic[2]) ) return; // styles not defined

  $key      = $this->style_dynamic[1];

  $arrStyle = $this->style_dynamic[2]; 

  $strStyle = '';

  if ( isset($arr[$key]) ) {

  if ( isset($arrStyle[strval($arr[$key])]) ) {

    $strStyle = (empty($this->style_td) ? '' : ';').sprintf( $this->style_dynamic[0], $arrStyle[strval($arr[$key])] );

  }}

  return $strStyle;

}



function AddClassDynamic($arr)

{

  // Change $this->style_td to add a dynamic style based on the parameters in $this->style_dynamic and according to the values in $arr

  if ( !is_array($arr) ) return; // row not defined

  if ( count($arr)==0 ) return; // row not defined

  if ( !is_array($this->class_dynamic) ) return; // formula not defined

  if ( count($this->class_dynamic)!=3 ) return; // formula not defined

  if ( !is_string($this->class_dynamic[0]) ) return; // formula not defined

  if ( !is_string($this->class_dynamic[1]) ) return; // formula not defined

  if ( !is_array($this->class_dynamic[2]) ) return; // styles not defined

  $key      = $this->class_dynamic[1];

  $arrClass = $this->class_dynamic[2]; 

  $strClass = '';

  if ( isset($arr[$key]) ) {

  if ( isset($arrClass[strval($arr[$key])]) ) {

    $strClass = ' '.sprintf( $this->class_dynamic[0], $arrClass[strval($arr[$key])] );

  }}

  return $strClass;

}



}



/**

 * VIP means Visitor In Page: This class includes info on the current user and the current page,

 * The class also provides major lists or global stats used in most of the pages

 * Here we extend the basic user's construction methods (cAuthenticate) to add support of Web/quickticket/quicktalk logins

 * Here we extend the basic Login method (cAuthenticate::Login) to return extra user's info

 */



class cVIP implements IAuthenticate

{



public $auth = false;         // authenticated

public $auth_coockie = false; // authentication is done by coockie

public $id = 0;

public $username = 'Guest';

public $fullname = '';

public $role = 'V';   // A=Administator,M=Moderator,U=User,V=Visitor

public $picture = '';



public $selfurl  = 'qte_index.php';

public $selfname = '';

public $exiturl  = 'qte_index.php';

public $exitname = 'Back';



public $domains = array();  // list of domains (translated) visible for the current user ($oVIP->role)

public $sections = array(); // list of sectionstitles (translated) visible for the current user ($oVIP->role)

public $types = array();    // list of types

public $statuses = array(); // list of statuses

public $states = array();   // other info

public $css = array();

public $output = 'screen'; // output media (screen,print)

public $members = 0;      // count members



// --------



function __construct()

{  



  // Basic login check <else> Coockie login check



  if ( $this->IsAuthenticated() )

  {

    $this->auth = true;

    if ( isset($_SESSION[QT.'_usr_id']) )       $this->id       = intval($_SESSION[QT.'_usr_id']);

    if ( isset($_SESSION[QT.'_usr_username']) ) $this->username = $_SESSION[QT.'_usr_username'];

    if ( isset($_SESSION[QT.'_usr_role']) )     $this->role     = $_SESSION[QT.'_usr_role'];

  }

  else

  {

    if ( isset($_COOKIE[QT.'_cookname']) && isset($_COOKIE[QT.'_cookpass']) )

    {

      global $oDB;

      $oDB->Query('SELECT * FROM '.TABUSER.' WHERE username="'.$_COOKIE[QT.'_cookname'].'" AND pwd="'.$_COOKIE[QT.'_cookpass'].'"');

      if ( $row = $oDB->Getrow() )

      {

        $this->auth = true;

        if ( isset($row['id']) )       $this->id       = intval($row['id']);

        if ( isset($row['username']) ) $this->username = $row['username'];

        if ( isset($row['firstname']) ) $this->fullname = (empty($row['firstname']) ? '' : $row['firstname']);

        if ( isset($row['lastname']) ) $this->fullname .= (empty($row['lastname']) ? $this->username : $row['lastname']);

        if ( isset($row['role']) )     $this->role     = substr($row['role'],0,1);

        $this->Register();

        $this->auth_coockie=true;

      }

    }  

  }

  // Web Team Login check



  if ( !$this->auth ) {

  if ( isset($_SESSION[QT]['login_qte_web']) ) {

  if ( !empty($_SESSION[QT]['login_qte_web']) ) {

    

    $this->LoginTeam('qte');



  }}}



  // QuickTicket login check



  if ( !$this->auth ) {

  if ( isset($_SESSION[QT]['login_qti']) ) {

  if ( !empty($_SESSION[QT]['login_qti']) ) {

    

    $this->LoginTeam($_SESSION[QT]['login_qti']);



  }}}



  // QuickTalk login check



  if ( !$this->auth ) {

  if ( isset($_SESSION[QT]['login_qtf']) ) {

  if ( !empty($_SESSION[QT]['login_qtf']) ) {

    

    $this->LoginTeam($_SESSION[QT]['login_qtf']);



  }}}



}



// --------



function GetTypes()

{

  global $L;

  return array('H'=>array('name'=>'Human','color'=>''),'O'=>array('name'=>'Other','color'=>''));

}



// --------



function IsPrivate($strFields,$strField,$id)

{

  // Check the privacy setting. $strField is in the list of private fields ($strFields)

  // Returns true/false if current user can see the private info

  if ( $this->IsStaff() ) return false;

  if ( $this->id==$id) return false;

  if ( strstr($strFields,$strField) ) return true;

  return false;

}



// --------



function IsStaff() { return ($this->role=='M' || $this->role=='A'); }



// --------

// DOLOGINTEAM check weblogin/teamlogin and return extra info (fullname and coppa)



function LoginTeam($sid='qte')

{

  if ( isset($_SESSION[$sid.'_usr_auth']) && ( isset($_SESSION[$sid.'_usr_name']) || isset($_SESSION[$sid.'_usr_username']) ) ) {

  if ( $_SESSION[$sid.'_usr_auth']=='yes' ) {

    

    // check coherence: name must exist

    global $oDB;

    if ( isset($_SESSION[$sid.'_usr_name']) ) { $str = $_SESSION[$sid.'_usr_name']; } else { $str=$_SESSION[$sid.'_usr_username']; }

    $oDB->Query( 'SELECT count(*) as countid FROM '.TABUSER.' WHERE username="'.$str.'"' );

    

    if ( $row = $oDB->Getrow() ) {

    if ( isset($row['countid']) ) {

    if ( $row['countid']==1 ) {    



      $this->auth = true;



      // Get user info

      $oDB->Query('SELECT id,username,role,children,status FROM '.TABUSER.' WHERE username="'.$str.'"');

      $row = $oDB->Getrow();

      $this->id = intval($row['id']);

      $this->username = $row['username'];

      $this->role = $row['role'];



      // Register VIP info in session

      $this->Register();



      return array('fullname'=>$str,'coppa'=>intval($row['children']),'status'=>$row['status']);

        

    }}}

    

  }}

  

  return array('fullname'=>'','coppa'=>0,'status'=>'Z');

}



// --------

// @$strTitle: title of the message box. When null or empty string, uses the page name ($this->selfname)

//  when $strTitle=="0", it makes a direct exit

// @$strMessage: message body.

// @$strSkin: the skin folder

// @$intTime: the pause (in second) before redirecting to the exit page. Use 0 to NOT redirect.

// @$strWidth: css width parameter ("300px" or "90%")

// @$strIdHead: css id of the header

// @$strIdMain: css id of the body



public function EndMessage($strTitle,$strMessage='Access denied',$strSkin='skin/default',$intTime=0,$strWidth='300px',$strTitleId='msgboxtitle',$strBodyId='msgbox')

{

  global $oHtml;

  $this->exiturl = str_replace('&amp;','&',$this->exiturl);

  if ( $strTitle=='0' ) $oHtml->Redirect($this->exiturl,$this->exitname);

  if ( empty($strTitle) ) $strTitle = $this->selfname;

  

  $oHtml->links   = array();

  $oHtml->links[] = '<link rel="shortcut icon" href="'.$strSkin.'/qte_icon.ico" />';

  $oHtml->links[] = '<link rel="stylesheet" type="text/css" href="'.$strSkin.'/qte_main.css" title="cssmain" />';

  $oHtml->links[] = '<link rel="stylesheet" type="text/css" href="bin/css/qte_print.css" media="print" />';

  echo $oHtml->Head();

  echo $oHtml->Body();

  HtmlPageCtrl(0,'90%');

  $oHtml->Msgbox($strTitle,array('style'=>'width:'.$strWidth),array('id'=>$strTitleId),array('id'=>$strBodyId));

  echo $strMessage,'

  <p><a id="exiturl" href="',Href($this->exiturl),'">',$this->exitname,'</a></p>';

  $oHtml->Msgbox();

  HtmlPageCtrl(1);



  if ( $intTime>0 )

  {

  echo '

  <script type="text/javascript">

  <!--

  setTimeout(\'window.location=document.getElementById("exiturl").href\',',($intTime*1000),');

  -->

  </script>

  ';

  }

  echo $oHtml->End();



  exit;

}



// --------

// $strCanView user role (V[i], U, M or A) that can access the page (i=public access level)

// $bStopOff stop when application off-line



function CanView($strCanView='V5',$bStopOff=true)

{  

  if ( $this->role=='A' ) { if ( $_SESSION[QT]['board_offline']=='1' ) echo '<p style="padding:4px;background-color:#ff0000;color:#ffffff">Board is offline but Administrators can make some actions.</p>'; return true; }

  if ( $strCanView=='U' && $this->role=='V') return false;

  if ( $strCanView=='M' && !$this->IsStaff() ) return false;  

  if ( $strCanView=='A' && $this->role!='A' ) return false;  

  if ( strlen($strCanView)==2 ) { $strPAL=substr($strCanView,-1,1); } else { $strPAL='5'; }

  if ( $this->role=='V' && $_SESSION[QT]['visitor_right']<$strPAL ) return false;

  if ( $_SESSION[QT]['board_offline']=='1' && $bStopOff ) return false;

  return true;

}



// --------



public function CanViewCalendar()

{

  if ( !isset($_SESSION[QT]['show_calendar']) ) return true;

  if ( $_SESSION[QT]['show_calendar']=='V' ) return true;

  if ( $_SESSION[QT]['show_calendar']=='U' && $this->role!='V' ) return true;

  return $this->IsStaff();

}



// --------



public function CanViewStats()

{

  if ( !isset($_SESSION[QT]['show_stats']) ) return true;

  if ( $_SESSION[QT]['show_stats']=='V' ) return true;

  if ( $_SESSION[QT]['show_stats']=='U' && $this->role!='V' ) return true;

  return $this->IsStaff();

}



// --------



public static function LangAdd($strType='',$strLang='en',$strId='',$strName='',$bCheck=false)

{

  QTargs( 'cVIP->LangAdd',array($strType,$strLang,$strId,$strName,$bCheck),array('str','str','str','str','boo') );

  QTargs( 'cVIP->LangAdd',array($strType,$strLang,$strId,$strName),'empty' );



  // Process



  global $oDB;

  if ( $bCheck )

  {

  $oDB->Query('SELECT count(objid) AS countid FROM '.TABLANG.' WHERE objtype="'.$strType.'" AND objlang="'.strtolower($strLang).'" AND objid="'.$strId.'"');

  $row=$oDB->Getrow();

  if ( $row['countid']!=0 ) return False;

  }

  $oDB->Query('INSERT INTO '.TABLANG.' (objtype,objlang,objid,objname) VALUES ("'.$strType.'","'.strtolower($strLang).'","'.$strId.'","'.addslashes(QTconv($strName,'3',QTE_CONVERT_AMP,false)).'")');

  return true;

}



// --------



public static function LangDel($strType='',$strId='')

{  

  if ( is_array($strType) ) $strType = implode('" OR objtype="',$strType);

  QTargs( 'cVIP->LangDel',array($strType,$strId) );

  QTargs( 'cVIP->LangDel',array($strType,$strId),'empty' );



  // Process



  global $oDB;

  $oDB->Query( 'DELETE FROM '.TABLANG.' WHERE (objtype="'.$strType.'") AND objid="'.$strId.'"' );

}



// --------



public static function LangGet($strType='',$strLang='en',$strId='*')

{

  // Return the object name (translated)

  // Can return an array of object names (in this language) when $strId is '*'

  // Can return an array of object translation when $strLang is '*'



  QTargs('cVIP->LangGet',array($strType,$strLang,$strId));

  QTargs('cVIP->LangGet',array($strType,$strLang,$strId),'empty');

  if ( $strId==='*' && $strLang==='*' ) die('cVIP->LangGet: Arg 2 and 3 cannot be *.');



  // Process



  global $oDB;

  if ( $strId==='*' )

  {

    $arr = array();

    $oDB->Query('SELECT objid,objname FROM '.TABLANG.' WHERE objtype="'.$strType.'" AND objlang="'.strtolower($strLang).'"');

    while($row=$oDB->Getrow())

    {

      if ( !empty($row['objname']) ) $arr[$row['objid']]=$row['objname'];

    }

    return $arr;

  }

  elseif ( $strLang==='*' )

  {

    $arr = array();

    $oDB->Query('SELECT objlang,objname FROM '.TABLANG.' WHERE objtype="'.$strType.'" AND objid="'.$strId.'"');

    while($row=$oDB->Getrow())

    {

      $arr[$row['objlang']]=$row['objname'];

    }

    return $arr;

  }

  else

  {

    $oDB->Query('SELECT objname FROM '.TABLANG.' WHERE objtype="'.$strType.'" AND objlang="'.strtolower($strLang).'" AND objid="'.$strId.'"');

    $row=$oDB->Getrow();

    return (empty($row['objname']) ? '' : $row['objname']);

  }

}



// --------



function SetSys()

{

  if ( !isset($_SESSION[QT]['sys_domains']) ) $_SESSION[QT]['sys_domains'] = GetDomains($this->role);

  if ( !isset($_SESSION[QT]['sys_sections']) ) $_SESSION[QT]['sys_sections'] = QTarrget(GetSections($this->role));

  if ( !isset($_SESSION[QT]['sys_statuses']) ) $_SESSION[QT]['sys_statuses'] = $this->GetStatuses();

  if ( !isset($_SESSION[QT]['sys_members']) ) $_SESSION[QT]['sys_members'] = $this->SysCount('members');

  if ( !isset($_SESSION[QT]['sys_states']) ) $_SESSION[QT]['sys_states'] = $this->SysCount('states');



  $this->domains = $_SESSION[QT]['sys_domains'];

  $this->sections = $_SESSION[QT]['sys_sections'];

  $this->statuses = $_SESSION[QT]['sys_statuses'];

  $this->members = $_SESSION[QT]['sys_members'];

  $this->states = $_SESSION[QT]['sys_states'];

}



// --------



function GetStatuses()

{

  $arr = array();



  global $oDB;  $oDB->Query( 'SELECT * FROM '.TABSTATUS.' ORDER BY id' );

  while($row=$oDB->Getrow())

  {

    $arr[$row['id']]['statusname'] = ucfirst(str_replace('_',' ',$row['name']));

    $arr[$row['id']]['statusdesc'] = '';

    $arr[$row['id']]['name'] = $row['name'];

    $arr[$row['id']]['icon'] = $row['icon'];

    $arr[$row['id']]['color'] = $row['color'];

  }



  // find translations



  $arrL = cVIP::LangGet('status',GetIso(),'*');

  foreach ($arrL as $id=>$str)

  {

    if ( !empty($str) ) $arr[$id]['statusname'] = $str;

  }

  $arrL = cVIP::LangGet('statusdesc',GetIso(),'*');

  foreach ($arrL as $id=>$str)

  {

    if ( !empty($str) ) $arr[$id]['statusdesc'] = $str;

  }



  return $arr;

}



// --------



function StatusAdd($id='',$name='',$icon='',$color='')

{

  QTargs('cVIP->StatusAdd',array($id,$name,$icon,$color));

  QTargs('cVIP->StatusAdd',array($id,$name),'empty');



  // Process



  global $oDB;

  $error = '';



  $id = strtoupper(substr(trim($id),0,1));

  $name = QTconv($name,'3',QTE_CONVERT_AMP);



  // unique id and name



  $oDB->Query('SELECT count(*) AS countid FROM '.TABSTATUS.' WHERE id="'.$id.'"');

  $row=$oDB->Getrow();

  if ( $row['countid']>0 ) $error = "Status id [$id] already used";

  $oDB->Query('SELECT count(*) AS countid FROM '.TABSTATUS.' WHERE name="'.addslashes($name).'"');

  $row=$oDB->Getrow();

  if ( $row['countid']>0 ) $error = "Status name [$name] already used";



  // Save



  if ( empty($error) )

  {

    $oDB->Query('INSERT INTO '.TABSTATUS.' (id,name,color,icon) VALUES ("'.$id.'","'.addslashes($name).'","'.$color.'","'.$icon.'")');

  }

  

  // Exit

  

  if ( isset($_SESSION[QT]['sys_statuses']) ) unset($_SESSION[QT]['sys_statuses']);

  return $error;

}



// --------



function StatusDelete($id='',$to='A')

{

  QTargs('cVIP->StatusDelete',array($id,$to) );

  QTargs('cVIP->StatusDelete',array($id,$to),'empty');

  $id = strtoupper(substr(trim($id),0,1));

  $to = strtoupper(substr(trim($to),0,1));

  if ( $id=='A' || $id=='A' ) die('cVIP->StatusDelete: Argument #1 cannot be A nor Z');

  if ( $id==$to ) die('cVIP->StatusDelete: Argument #1 equal #2');



  // Process - status id > to and delete id

  

  global $oDB;



  $oDB->Query( 'UPDATE '.TABUSER.' SET status="'.$to.'" WHERE status="'.$id.'"' );

  $oDB->Query( 'DELETE FROM '.TABSTATUS.' WHERE id="'.$id.'"' );

  $oDB->Query( 'DELETE FROM '.TABLANG.' WHERE (objtype="status" OR objtype="statusdesc") AND objid="'.$id.'"' );



  // Exit



  if ( isset($_SESSION[QT]['sys_statuses']) ) unset($_SESSION[QT]['sys_statuses']);

}



// --------



function StatusChangeId($id='',$to='')

{

  QTargs('cVIP->StatusChangeId',array($id,$to));

  QTargs('cVIP->StatusChangeId',array($id,$to),'empty');

  $id = strtoupper(substr(trim($id),0,1));

  $to = strtoupper(substr(trim($id),0,1));

  if ( $id=='A' || $id=='Z' ) die('cVIP->StatusChangeId: Argument #1 cannot be A nor Z');

  if ( $to=='A' || $to=='Z' ) die('cVIP->StatusChangeId: Argument #2 cannot be A nor Z');



  // Process

  

  global $oDB;

  $error = '';



  // Unique name



  if ( empty($error) )

  {

  $oDB->Query('SELECT count(*) AS countid FROM '.TABSTATUS.' WHERE status="'.$to.'"');

  $row=$oDB->Getrow();

  if ( $row['countid']>0 ) $error = "Status id [$id] already used";

  }



  // Save changes



  if ( empty($error) )

  {

  $oDB->Query('UPDATE '.TABUSER.' SET status="'.$to.'" WHERE status="'.$id.'"');

  $oDB->Query('UPDATE '.TABSTATUS.' SET id="'.$to.'" WHERE id="'.$id.'"');

  }



  // Exit

  

  if ( isset($_SESSION[QT]['sys_statuses']) ) unset($_SESSION[QT]['sys_statuses']);

  return $error;

}



// --------



protected function Register()

{  

  $_SESSION[QT.'_usr_auth'] = 'yes';

  $_SESSION[QT.'_usr_id'] = $this->id;

  $_SESSION[QT.'_usr_username'] = $this->username;

  $_SESSION[QT.'_usr_fullname'] = $this->fullname;

  $_SESSION[QT.'_usr_role'] = $this->role;

  $_SESSION[QT.'_usr_picture'] = $this->picture;

}



// --------



function SysCount($strObject='members')

{

  // Check

  

  if ( !is_string($strObject) ) die('SysCount: Invalid argument type (expect string)');



  // Process

  

  global $oDB;

  switch($strObject)

  {

  case 'members':

    $oDB->Query('SELECT count(*) as countid FROM '.TABUSER.' WHERE id>0');

    $row = $oDB->Getrow();

    return intval($row['countid']);

    break;

  case 'states':

    $arr = array();

      $oDB->Query('SELECT max(id) as countid FROM '.TABUSER);

      $row = $oDB->Getrow();

    $arr['newuserid'] = intval($row['countid']);

      $oDB->Query('SELECT username,firstname,lastname FROM '.TABUSER.' WHERE id='.$row['countid'] );

      $row = $oDB->Getrow();

    $arr['newusername'] =  $row['firstname'].' '.$row['lastname']; if ( strlen($arr['newusername'])<3 ) $arr['newusername'] = $row['username'];

    return $arr;

    break;

  }

}



// --------

// interface methods

// --------



public function IsAuthenticated()

{

  if ( isset($_SESSION[QT.'_usr_auth']) ) { if ( $_SESSION[QT.'_usr_auth']=='yes' ) return true; }

  return false;

}



// --------



public function Login($strUsername='',$strPwd='',$bRemember=FALSE)

{

  // login and return extra info (fullname and coppa)



  global $oDB;

  $oDB->Query( 'SELECT count(*) as countid FROM '.TABUSER.' WHERE username="'.$strUsername.'" AND pwd="'.sha1($strPwd).'"' );



  if ( $row = $oDB->Getrow() ) {

  if ( isset($row['countid']) ) {

  if ( $row['countid']==1 ) {



    $this->auth = true;



    // Get user info

    $oDB->Query('SELECT id,role,children,status,firstname,lastname FROM '.TABUSER.' WHERE username="'.$strUsername.'" AND pwd="'.sha1($strPwd).'"');

    $row = $oDB->Getrow();

    $this->id = intval($row['id']);

    $this->username = $strUsername;

    $this->role = $row['role'];



    // Register VIP info in session

    $this->Register();



    if ( $bRemember )

    {

    setcookie(QT.'_cookname', htmlspecialchars($this->username,ENT_QUOTES), time()+60*60*24*100, '/');

    setcookie(QT.'_cookpass', sha1($strPwd), time()+60*60*24*100, '/');

    setcookie(QT.'_cooklang', $_SESSION[QT]['language'], time()+60*60*24*100, '/');

    }



    // Reset parameters (because the Role can impact the lists)

    unset($_SESSION[QT]['sys_sections']);



    return array('username'=>$strUsername,'coppa'=>intval($row['children']),'status'=>$row['status'],'firstname'=>$row['firstname'],'lastname'=>$row['lastname']);



  }}}



  return array('username'=>'','coppa'=>0,'status'=>'Z','firstname'=>'','lastname'=>'');



}



// --------



public function Logout()

{

  // Remove session info (and cookie)

  $_SESSION=array();

  session_destroy();

  if ( isset($_COOKIE[QT.'_cookname']) ) setcookie(QT.'_cookname', '', time()+60*60*24*100, '/');

  if ( isset($_COOKIE[QT.'_cookpass']) ) setcookie(QT.'_cookpass', '', time()+60*60*24*100, '/');

  if ( isset($_COOKIE[QT.'_cooklang']) ) setcookie(QT.'_cooklang', '', time()+60*60*24*100, '/');

}



// --------



}