<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5.1 build:20110505
 */

session_start();
require_once('bin/qte_init.php');
if ( $oVIP->role!='A' ) die($L['R_admin']);

// ---------
// INITIALISE
// ---------

$s = -1; QThttpvar('s','int'); if ( $s<0 ) die('Missing parameters');

include(Translate('qte_adm.php'));

$oVIP->selfurl  = 'qte_adm_section.php?s='.$s;
$oVIP->selfname = '<span class="upper">'.$L['Adm_content'].'</span><br />'.$L['Section_upd'];
$oVIP->exiturl  = 'qte_adm_sections.php';
$oVIP->exitname = '&laquo; '.$L['Sections'];

$arrStaff = GetUsers('M',-1); // staff id,username,firstname,lastname (as array)
if ( count($arrStaff)>10 ) { $bAjax=true; } else { $bAjax=false; }

$oSEC = new cSection($s);

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // CHECK MANDATORY VALUE

  $str = trim(strip_tags($_POST['title'])); if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
  $str = QTconv($str,'3',QTE_CONVERT_AMP,false);
  if ( empty($str) ) $error = $L['Title'].S.$L['E_invalid'];

  if ( empty($error) )
  {
    $oSEC->id = $s;
    $oSEC->parentid = $_POST['domid'];
    $oSEC->name = $str;
    $oSEC->type = intval($_POST['type']);
    $oSEC->status = intval($_POST['status']);
    // with ajax, validate the modname
    if ( $bAjax && isset($_POST['modname']) )
    {
      if ( $_POST['modname']!=$_POST['modnameold'] )
      {
      $arr = FormatUsers($arrStaff,'fl');
      $oSEC->modname = trim($_POST['modname']);
      $oSEC->modid = array_search($oSEC->modname,$arr);
      if ( $oSEC->modid==FALSE || empty($oSEC->modid) ) { $oSEC->modid=1; $oSEC->modname='Admin'; $warning=$L['Section_moderator'].S.$L['E_invalid']; }
      }
    }
    if ( isset($_POST['modid']) )
    {
      if ( $_POST['modid']!=$_POST['modidold'] )
      {
        $arr = FormatUsers($arrStaff,'fl');
        $oSEC->modname = $arr[$_POST['modid']];
        $oSEC->modid = $_POST['modid'];
      }
    }
  }

  // SAVE

  if ( empty($error) )
  {
    // update
    $oDB->Query('UPDATE '.TABSECTION.' SET domainid='.$oSEC->parentid.', title="'.$oSEC->name.'", type="'.$oSEC->type.'", status="'.$oSEC->status.'", modid='.$oSEC->modid.', modname="'.$oSEC->modname.'" WHERE id='.$oSEC->id);
    
    // translation
    $oDB->Query('DELETE FROM '.TABLANG.' WHERE (objtype="sec" OR objtype="secdesc") AND objid="s'.$oSEC->id.'"');
    foreach ($_POST as $strKey => $strTranslation)
    {
      if ( substr($strKey,0,1)=='T' )
      {
        if ( !empty($strTranslation) )
        {
        if ( get_magic_quotes_gpc() ) $strTranslation = stripslashes($strTranslation);
        cVIP::LangAdd('sec',substr($strKey,1),'s'.$oSEC->id,$strTranslation);
        }
      }
      if ( substr($strKey,0,1)=='D' )
      {
        if ( !empty($strTranslation) )
        {
        if ( get_magic_quotes_gpc() ) $strTranslation = stripslashes($strTranslation);
        cVIP::LangAdd('secdesc',substr($strKey,1),'s'.$oSEC->id,$strTranslation);
        }
      }
    }

    // register section lang and description

    $_SESSION['L']['sec'] = cVIP::LangGet('sec',GetIso(),'*');
    $_SESSION['L']['secdesc'] = cVIP::LangGet('secdesc',GetIso(),'*');
    Unset($oVIP->sections);
    Unset($_SESSION[QT]['sys_notifysections']);
    
    // exit
    $strInfo = $L['S_save'];
  }
}

// --------
// HTML START
// --------

if ( $bAjax )
{
$strHeadScript = '
<link rel="stylesheet" type="text/css" href="bin/css/qt_jquery.css" title="cssmain" />
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript" src="bin/qt_jquery_auto.js"></script>
<script type="text/javascript">
<!--
$(document).ready(function() {
  $("#modname").autocomplete("qte_j_name.php", {
    selectFirst: false,
    extraParams: { r:"M" },
    formatItem: function(value) { return value[1] + " (" + value[0] + ")"; },
    formatResult: function(value) { return value[1]; }    
  });
});
-->
</script>';
}

include('qte_adm_p_header.php');

$arrDest = $oVIP->domains;
Unset($arrDest[$oSEC->parentid]);

// FORM

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': ',$L['Title'],'")); return false; }
  return null;
}
-->
</script>
';

echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<table class="data_o" cellspacing="0">
<tr class="tr">
<td class="colhd colhdgroup" colspan="2"><b>',$L['Definition'],'</b></td>
</tr>
<tr class="tr">
<td class="colhd colhdfirst" style="width:150px"><span class="texthead">Id</span></td>
<td class="colct">',$oSEC->id,'</td>
</tr>
';
$str = QTconv($oSEC->title,'I');
echo '<tr class="tr tr_o">
<td class="colhd" style="width:150px; text-align:right"><span class="texthead"><label for="title">',$L['Title'],'</label></span></td>
<td class="colct"><input type="text" id="title" name="title" size="55" maxlength="64" value="',$str,'" style="background-color:#FFFF99;" onchange="bEdited=true;"/>',(strstr($str,'&amp;') ?  ' <span class="disabled">'.$oSEC->title.'</span>' : ''),'</td>
</tr>
';
echo '<tr class="tr tr_o">
<td class="colhd" style="width:150px; text-align:right"><span class="texthead">',$L['Domain'],'</span></td>
<td class="colct"><select name="domid" onchange="bEdited=true;">
<option value="',$oSEC->parentid,'"',QSEL,'>',$oVIP->domains[$oSEC->parentid],'</option>',QTasTag($arrDest,'',array('format'=>$L['Move_to'].': %s')),'</select></td>
</tr>
';
echo '<tr class="tr">
<td class="colhd colhdgroup" colspan="2"><b>',$L['Options'],'</b></td>
</tr>
';
echo '<tr class="tr">
<td class="colhd colhdfirst" style="width:150px"><span class="texthead"><label for="type">',$L['Type'],'</label></span></td>
<td class="colct">
<select id="type" name="type" onchange="bEdited=true;">
<option value="0"',($oSEC->type=='0' ? QSEL : ''),'>',$L['Section_type'][0],'</option>
<option value="1"',($oSEC->type=='1' ? QSEL : ''),'>',$L['Section_type'][1],'</option>
</select> ',$L['Status'],' <select id="status" name="status" onchange="bEdited=true;">
<option value="0"',($oSEC->status=='0' ? QSEL : ''),'>',$L['Section_status'][0],'</option>
<option value="1"',($oSEC->status=='1' ? QSEL : ''),'>',$L['Section_status'][1],'</option>
</select>
</tr>
';
if ( $bAjax )
{
echo '<tr class="tr">
<td class="colhd colhdfirst" style="width:150px"><span class="texthead">',$L['Section_moderator'],'</span></td>
<td class="colct"><input type="hidden" name="modnameold" value="',$oSEC->modname,'"/>
<input type="text" name="modname" id="modname" value="',$oSEC->modname,'" size="32" maxlength="32" onchange="bEdited=true;"/>
</td>
</tr>
';
}
else
{
echo '<tr class="tr">
<td class="colhd colhdfirst" style="width:150px"><span class="texthead">',$L['Section_moderator'],'</span></td>
<td class="colct"><input type="hidden" name="modidold" value="',$oSEC->modid,'"/>
<select name="modid" id="modid" onchange="bEdited=true;"/>',QTasTag(FormatUsers($arrStaff,'flu'),$oSEC->modid,array('current'=>$oSEC->modid,'classC'=>'bold')),'</select>
</td>
</tr>
';
}
echo '<tr class="tr">
<td class="colhd colhdfirst" style="width:150px"><span class="texthead">',$L['Picture'],'</span></td>
<td class="colct">',( !empty($oSEC->d_logo) ? AsImg('document/section/'.$oSEC->d_logo) : '' ),' <a href="qte_adm_section_img.php?id=',$oSEC->id,'" onclick="return qtEdited(bEdited,\''.$L['E_editing'].'\');">',$L['Change'],'...</a></td>
</tr>
';
echo '<tr class="tr">
<td class="colhd colhdfirst" style="width:150px"><span class="texthead">',$L['Columns'],'</span></td>
<td class="colct">',implode(', ',GetFLDnames(GetFLDs($oSEC->forder))),' &middot; <a href="qte_adm_section_col.php?s=',$oSEC->id,'" onclick="return qtEdited(bEdited,\''.$L['E_editing'].'\');">',$L['Edit'],'</a></td>
</tr>
';
echo '<td class="colhd colhdgroup" colspan="3">',$L['Translations'],'</td>
<tr class="tr tr_o">
<td class="colhd colhdfirst">',$L['Section_name_and_desc'],'</td>
<td class="colct" colspan="2">
<p class="help">',sprintf($L['E_no_translation'],$oSEC->title),'</p>
<table cellspacing="0" class="hidden">';
$arrTrans = $oVIP->LangGet('sec','*','s'.$oSEC->id);
$arrDescTrans = $oVIP->LangGet('secdesc','*','s'.$oSEC->id);
include('bin/qte_lang.php'); // this creates $arrLang
foreach ($arrLang as $strIso => $arr)
{
  $str = '';
  if ( isset($arrTrans[$strIso]) ) {
  if ( !empty($arrTrans[$strIso]) ) {
    $str = QTconv($arrTrans[$strIso],'I');
  }}
  echo '
  <tr class="hidden">
  <td class="hidden" style="width:25px"><span title="',$arr[1],'">',$arr[0],'</span></td>
  <td class="hidden" style="width:220px"><input class="small" title="',$L['Section'],' (',$strIso,')" type="text" id="T',$strIso,'" name="T',$strIso,'" size="32" maxlength="64" value="',$str,'" onchange="bEdited=true;"/>&nbsp;',(strstr($str,'&amp;') ?  '<br /><span class="disabled">'.$arrTrans[$strIso].'</span>' : ''),'</td>';
  $str = '';
  if ( isset($arrDescTrans[$strIso]) ) {
  if ( !empty($arrDescTrans[$strIso]) ) {
    $str = QTconv($arrDescTrans[$strIso],'I');
  }}
  echo '<td class="hidden"><textarea class="small" title="',$L['Description'],' (',$strIso,')" type="text" id="D',$strIso,'" name="D',$strIso,'" cols="45" rows="2">',$str,'</textarea></td>
  </tr>
  ';
}
echo '</table>
</td>
</tr>
';
echo '<tr class="tr">
<td class="colhd" colspan="2" style="padding:6px; text-align:center"><input type="hidden" name="s" value="',$oSEC->id,'"/><input type="submit" name="ok" value="',$L['Save'],'"/></td>
</tr>
';
echo '</table>
</form>
<p><a href="',$oVIP->exiturl,'" onclick="return qtEdited(bEdited,\''.$L['E_editing'].'\');">',$oVIP->exitname,'</a></p>
';

// --------
// HTML END
// --------

include('qte_adm_p_footer.php');