<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5.1 build:20110505
 */

session_start();
require_once('bin/qte_init.php');
if ( $oVIP->role!='A' ) die($L['E_admin']);
$id = -1; QThttpvar('id','int'); if ( $id<0 ) die('Missing parameter id...');

// --------
// INITIALISE
// --------

include(Translate('qte_reg.php'));

if ( !isset($_SESSION['temp_key']) ) $_SESSION['temp_key']= '';
if ( !isset($_SESSION['temp_ext']) ) $_SESSION['temp_ext']= '';

$oVIP->selfurl = 'qte_adm_section_img.php';
$oVIP->selfname = $L['Change_picture'];
$oVIP->exiturl = 'qte_adm_section.php?s='.$id;

$upload_path = 'document/section/'; // The path to where the image will be saved
$large_image_location = $upload_path.'src'.$id.'_'.$_SESSION['temp_key'].$_SESSION['temp_ext'];
$thumb_image_location = $upload_path.$id.$_SESSION['temp_ext'];

if ( isset($_POST['exit']) )
{
  // Exit request code is placed before as following object initialisation is not required in case of exiting
  if ( file_exists($large_image_location) ) unlink($large_image_location);
  unset($_SESSION['temp_key']);
  $oHtml->Redirect($oVIP->exiturl);
}

$oSEC = new cSection($id);  // section-logo directory is 'document/section' (even if DIR_DOC is changed)

$max_file = 2;       // Maximum file size in MB
$max_width = 650;    // Display width for the large image
$thumb_max_width = 200; // Above this value, the crop tool will start
$thumb_max_height = 200; // Above this value, the crop tool will start
$thumb_width = 120;  // Width of thumbnail image
$thumb_height = 100; // Height of thumbnail image
$strMimetypes = 'image/pjpeg,image/jpeg,image/jpg,image/gif,image/png,image/x-png';
$photo = (empty($oSEC->d_logo) ? '' :  'document/section/'.$oSEC->d_logo); // Current photo (Can be empty)
$photolabel = '';

//Check to see if any images with the same name already exist
$large_photo_exists = ''; if ( file_exists($large_image_location) ) $large_photo_exists = '<img src="'.$large_image_location.'" alt="Large image"/>';

function saveThumbnail($id,$str)
{
  global $oSEC;
  $oSEC->ChangeOption('logo',$id.$_SESSION['temp_ext']);
}

// --------
// SUBMITTED FOR DELETE
// --------

if ( isset($_POST['del']) )
{
  unlink('document/section/'.$oSEC->d_logo);
  $oSEC->ChangeOption('logo','');
  unset($_SESSION['temp_key']);
  $oVIP->selfname = $L['Picture'];
  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
}

// --------
// PAGE
// --------

$oHtml->links = array();
$oHtml->links[] = '<link rel="shortcut icon" href="admin/qte_icon.ico" />';
$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="admin/qte_main.css" title="cssmain" />';
$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="bin/css/qte_print.css" media="print" />';

include('qte_upload_img.php');