<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
if ( $oVIP->role!='A' ) die($L['R_admin']);
include(Translate('qte_adm.php'));

function arrShift($arrSrc,$intObject,$strDir)
{
  $arrTemp = $arrSrc;

  // search for the value
  foreach ($arrSrc as $intKey => $intValue)
  {
  if ( $intValue==$intObject ) $intNewkey = $intKey;
  }
  if ( !isset($intNewkey) ) return false;
  if ( $intNewkey==0 && $strDir=='up' ) return $arrSrc;
  if ( $intNewkey==(count($arrSrc)-1) && $strDir=='down' ) return $arrSrc;

  // reorder the elements
  if ( $strDir=='up' ) { $intDir = -1; } else { $intDir = 1; }
  $arrTemp[$intNewkey+$intDir] = $arrSrc[$intNewkey];
  $arrTemp[$intNewkey] = $arrSrc[$intNewkey+$intDir];

  // return the ordered array
  return $arrTemp;
}

// ---------
// INITIALISE
// ---------

$a='';
$d=-1;
$s=-1;
QThttpvar('a d s','str int int');
if ( isset($_SESSION['fields']) ) unset($_SESSION['fields']);

$oVIP->selfurl = 'qte_adm_sections.php';
$oVIP->selfname = '<span class="upper">'.$L['Adm_content'].'</span><br />'.$L['Sections'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['adddomain']) )
{
  $str = $_POST['title']; if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
  $str = QTconv($str,'3',QTE_CONVERT_AMP,false);
  if ( empty($str) ) $error = $L['Title'].S.$L['E_invalid'];
  if ( empty($error) )
  {
  require_once('bin/qte_class_dom.php');
  cDomain::Create($str,0);
  }
}

if ( isset($_POST['addteam']) )
{
  $str = $_POST['title']; if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
  $str = QTconv($str,'3',QTE_CONVERT_AMP);
  if ( empty($str) ) $error = $L['Title'].S.$L['E_invalid'];
  if ( empty($error) ) cSection::Create($str,intval($_POST['indomain']));
}

if ( !empty($a) )
{
  if ( $a=='d_up' || $a=='d_down' )
  {
    $oDB->Query('SELECT id FROM '.TABDOMAIN.' ORDER BY vorder');
    $arrList = array();
    while($row=$oDB->Getrow()) $arrList[]=intval($row['id']);
    $arrO = array_values(arrShift($arrList,$d,substr($a,2)));
    foreach($arrO as $intKey=>$intId) $oDB->Query('UPDATE '.TABDOMAIN.' SET vorder='.$intKey.' WHERE id='.$intId);
    if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  }
  if ( $a=='f_up' || $a=='f_down' )
  {
    $oDB->Query('SELECT id FROM '.TABSECTION.' WHERE domainid='.$d.' ORDER BY vorder');
    $arrList = array();
    while($row=$oDB->Getrow()) $arrList[]=intval($row['id']);
    $arrO = array_values(arrShift($arrList,$s,substr($a,2)));
    foreach($arrO as $intKey=>$intId) $oDB->Query('UPDATE '.TABSECTION.' SET vorder='.$intKey.' WHERE id='.$intId);
    if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  }
}

// --------
// HTML START
// --------

$arrDomains = GetDomains(); 
if ( count($arrDomains)>50 ) $warning='You have too much domains. Try to remove unused domains.';
$arrSections = GetSections('A',-2); // Optimisation: get all sections at once (grouped by domain)
if ( count($arrSections)>100 ) $warning='You have too much sections. Try to remove unused sections.';

include('qte_adm_p_header.php');

echo '<table class="data_o" cellspacing="0">
<colgroup span="7"><col width="30"></col><col width="50"></col><col></col><col></col><col></col><col></col><col></col></colgroup>
<tr class="tr">
<td class="colhd">Id</td>
<td class="colhd" colspan="2" style="text-align:left">',$L['Domain'],'/',$L['Section'],'</td>
<td class="colhd">',$L['Section_moderator'],'</td>
<td class="colhd">',$L['Action'],'</td>
<td class="colhd">',$L['Move'],'</td>
<td class="colhd">',$L['Users'],'</td>
</tr>
';

$i=0;
foreach($arrDomains as $intDomain=>$strDomain)
{
  echo '<tr class="tr">',PHP_EOL;
  echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
  echo '<td class="colgroup" colspan="2">',$strDomain,'</td>',PHP_EOL;
  echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
  echo '<td class="colgroup" style="text-align:center"><a class="small" href="qte_adm_domain.php?d=',$intDomain,'">',$L['Edit'],'</a>';
  echo ' &middot; ',($intDomain==0 ? '<span class="disabled">'.$L['Delete'].'</span>' : '<a class="small" href="qte_change.php?a=deletedomain&amp;s='.$intDomain.'">'.$L['Delete'].'</a>'),'</td>',PHP_EOL;
  echo '<td class="colgroup" style="text-align:center">';
  if ( $i==0 )
  {
  echo '<span class="disabled">',$L['Up'],'</span>';
  }
  else
  {
  echo '<a class="small" href="qte_adm_sections.php?d=',$intDomain,'&amp;a=d_up">',$L['Up'],'</a>';
  }
  echo ' &middot; ';
  if ( $i+1==count($oVIP->domains) )
  {
  echo '<span class="disabled">',$L['Down'],'</span>';
  }
  else
  {
  echo '<a class="small" href="qte_adm_sections.php?d=',$intDomain,'&amp;a=d_down">',$L['Down'],'</a>';
  }
  echo '</td>',PHP_EOL;
  echo '<td class="colgroup" style="text-align:center">&nbsp;</td>',PHP_EOL;

  $i += 1;

  $j = 0;
  if ( isset($arrSections[$intDomain]) ) {
  if ( count($arrSections[$intDomain])>0 ) {
  foreach($arrSections[$intDomain] as $intSecid=>$arrSection) {    
  
    $oSEC = new cSection($arrSection);
    echo '<tr class="tr">',PHP_EOL;
    echo '<td class="colct" style="text-align:center">',$oSEC->id,'</td>',PHP_EOL;
    echo '<td class="colct" style="text-align:center">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_'.$oSEC->type.'_'.$oSEC->status.'.gif','[+]',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'ico i_sec','','qte_adm_section.php?d='.$intDomain.'&amp;s='.$oSEC->id),'</td>';
    echo '<td class="colct"><a class="bold" href="qte_adm_section.php?d=',$intSecid,'&amp;s=',$oSEC->id,'">',$oSEC->name,'</a><br /><span class="small">',$L['Section_type'][$oSEC->type],($oSEC->status=='1' ? '<br><span class="small">('.$L['Section_status'][1].')</span>' : ''),'</span></td>';
    echo '<td class="colct small" style="text-align:center">',$oSEC->modname,'</td>',PHP_EOL;
    echo '<td class="colct small" style="text-align:center">
    <a class="small" href="qte_adm_section.php?d=',$intDomain,'&amp;s=',$oSEC->id,'">',$L['Edit'],'</a> &middot; 
    '.($intSecid==0 ? '<span class="disabled">'.$L['Delete'].'</span>' : '<a class="small" href="qte_change.php?a=deletesection&amp;s='.$intSecid.'">'.$L['Delete'].'</a>'),'</td>',PHP_EOL;
    echo '<td class="colct" style="text-align:center">';
    if ( $j==0 )
    {
    echo '<span class="disabled">',$L['Up'],'</span>';
    }
    else
    {
    echo '<a class="small" href="qte_adm_sections.php?d=',$intDomain,'&amp;s=',$intSecid,'&amp;a=f_up">',$L['Up'],'</a>';
    }
    echo ' &middot; ';
    if ( $j+1==count($arrSections[$intDomain]) )
    {
    echo '<span class="disabled">',$L['Down'],'</span>';
    }
    else 
    {
    echo '<a class="small" href="qte_adm_sections.php?d=',$intDomain,'&amp;s=',$intSecid,'&amp;a=f_down">',$L['Down'],'</a>';
    }
    $j += 1;
    echo '</td>',PHP_EOL;
    echo '<td class="colct" style="text-align:center">',$oSEC->members,' &middot; <a class="small" href="qte_adm_users_move.php?s=',$oSEC->id,'">',$L['User_man'],'</a></td>',PHP_EOL;
    echo '</tr>',PHP_EOL;
  
  }}}

}
echo '</table>
<p class="right"><a href="qte_adm_sections_stat.php">',$L['Update_stats'],'...</a></p>
';

echo '<h2>',$L['Section_add'],'</h2>
';

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': ',$L['Domain'],'/',$L['Section'],'")); return false; }
  return null;
}
-->
</script>
';

echo '<form method="post" action="qte_adm_sections.php" onsubmit="return ValidateForm(this);">
<table class="data_o" cellspacing="0">
<tr class="tr">
<td class="colgroup" style="width:130px;">',$L['Domain_add'],'</td>
<td class="colgroup"><input name="title" type="text" size="30" maxlength="64" /></td>
<td class="colgroup" style="width:75px;"><input id="adddomain" name="adddomain" type="submit" value="',$L['Add'],'" /></td>
</tr>
</table>
</form>
';
echo '<form method="post" action="qte_adm_sections.php" onsubmit="return ValidateForm(this);">
<table class="data_o" cellspacing="0">
<tr class="tr">
<td class="colct" style="width:130px;">',$L['Section_add'],'</td>
<td class="colct">
<input name="title" type="text" size="30" maxlength="64"/> <span class="small">',strtolower($L['In_domain']),'</span> <select name="indomain" size="1" class="small">',QTasTag($oVIP->domains),'</select>
</td>
<td class="colct" style="width:75px;"><input name="addteam" type="submit" value="',$L['Add'],'" /></td>
</tr>
</table>
</form>
';

// --------
// HTML END
// --------

include('qte_adm_p_footer.php');