<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   People management
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110418
 */

session_start();
require_once('bin/qte_init.php');
if ( $oVIP->role!='A' ) die($L['R_admin']);

// ---------
// INITIALISE
// ---------

include(Translate('qte_adm.php'));
include(Translate('qte_reg.php'));
include('bin/qte_fn_sql.php');

$s = 0; QThttpvar('s','int');

$oVIP->selfurl = 'qte_adm_users.php';
$oVIP->exiturl = 'qte_adm_users.php';

// --------
// SUBMITTED for delete
// --------

if ( isset($_POST['action']) ) {
if ( $_POST['action']=='delete' ) {

  $arr = array();
  if ( isset($_POST['user']) ) $arr = (is_array($_POST['user']) ? $_POST['user'] : explode(',',$_POST['user']));

  if ( count($arr)>0 )
  {
      // ask confirmation
      $oVIP->selfname = $L['User_del'];
      $oVIP->exitname = '&laquo; '.$L['Users'];
      if ( !isset($_POST['confirm']) )
      {
        $oVIP->EndMessage
        (
        NULL,
        '<table class="hidden" cellspacing="0">
        <tr class="hidden">
        <td class="hidden">
        <form method="post" action="'.$oVIP->selfurl.'">
        <p style="text-align:right">'.$L['Delete'].' ('.LangS('User',count($arr)).')</p>
        <p style="text-align:right"><input type="hidden" name="action" value="delete"/><input type="hidden" name="confirm" value="1"/><input type="hidden" name="user" value="'.implode(',',$arr).'"/><input type="submit" name="ok" value="'.$L['Delete'].' !"/></p>
        </form>
        </td>
        </tr>
        </table>',
        'admin',
        0,
        '500px'
        );
        exit;
      }
      else
      {
        // delete (except admin and visitor)
        foreach($arr as $id) {
        if ($id>1) {
          $oUser = new cUser($id);
          $oUser->Delete(false); // stats are update after (all at once)
        }}
        // update section stats
        foreach($_SESSION[QT]['sys_sections'] as $intId=>$arr) UpdateSectionStats($intId);
        // End message
        $strInfo = LangS('User',count($arr)).'. '.$L['S_delete']; 
      }
  }
  else
  {
  $warning = $L['E_nothing_selected'];
  }
}}

// --------
// SUBMITTED for status
// --------

if ( isset($_POST['action']) ) {
if ( $_POST['action']=='status' ) {

  $arr = array();
  if ( isset($_POST['user']) ) $arr = (is_array($_POST['user']) ? $_POST['user'] : explode(',',$_POST['user']));

  if ( count($arr)>0 )
  {
      // ask status and confirmation
      $oVIP->selfname = $L['Change_status'];
      $oVIP->exitname = '&laquo; '.$L['Users'];
      if ( !isset($_POST['confirm']) )
      {
        $oVIP->EndMessage
        (
        NULL,
        '<table class="hidden" cellspacing="0">
        <tr class="hidden">
        <td class="hidden">
        <form method="post" action="'.$oVIP->selfurl.'">
        <p style="text-align:right">'.$L['Status'].' <select name="status" size="1">'.QTasTag($oVIP->statuses).'</select>&nbsp;</p>
        <p style="text-align:right">('.LangS('User',count($arr)).') <input type="hidden" name="action" value="status"/><input type="hidden" name="confirm" value="1"/><input type="hidden" name="user" value="'.implode(',',$arr).'"/><input type="submit" name="ok" value="'.$L['Ok'].'"/></p>
        </form>
        </td>
        </tr>
        </table>',
        'admin',
        0,
        '500px'
        );
        exit;
      }
      else
      {
        // status (except admin and visitor)
        $str = '';
        foreach($arr as $id) if ($id>1) $str.=','.$id;
        $oDB->Query('UPDATE '.TABUSER.' SET status="'.strtoupper(substr($_POST['status'],0,1)).'" WHERE id IN ('.substr($str,1).')');
        // End message
        $strInfo = LangS('User',count($arr)).'. '.$L['S_update']; 
      }
  }
  else
  {
  $warning = $L['E_nothing_selected'];
  }
}}

// --------
// SUBMITTED for add
// --------

if ( isset($_POST['add']) )
{
  // check
  if ( empty($error) )
  {
    $str = $_POST['title']; if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
    $str = QTconv($str,'U');
    if ( !QTislogin($str) ) $error = ObjTrans('field','username').' '.$L['E_invalid'];
    $strTitle = $str;
  }
  if ( empty($error) )
  {
    $oDB->Query('SELECT count(*) as countid FROM '.TABUSER.' WHERE username="'.htmlspecialchars($strTitle,ENT_QUOTES).'"');
    $row = $oDB->Getrow();
    if ($row['countid']!=0) $error = ObjTrans('field','username').' '.$L['E_already_used'];
  }
  if ( empty($error) )
  {
    $str = $_POST['pass']; if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
    $str = QTconv($str,'U');
    if ( !QTispassword($str) ) $error = $L['Password'].' '.$L['E_invalid'];
    $strNewpwd = $str;
  }
  if ( empty($error) )
  {
    $str = $_POST['mail']; if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
    $str = QTconv($str,'U');
    if ( !QTismail($str) ) $error = $L['Email'].' '.$L['E_invalid'];
    $strMail = $str;
  }
  // save
  if ( empty($error) )
  {
    include('bin/qt_lib_smtp.php');

    $id = $oDB->Nextid(TABUSER);
    $oDB->Query( 'INSERT INTO '.TABUSER.' (id,role,username,lastname,pwd,emails,children,status,firstdate) VALUES ('.$id.',"U","'.htmlspecialchars($strTitle,ENT_QUOTES).'","'.htmlspecialchars($strTitle,ENT_QUOTES).'","'.sha1($strNewpwd).'","'.$strMail.'","0","'.$_POST['status'].'","'.date('Ymd').'")' );
    $oDB->Query( 'INSERT INTO '.TABS2U.' (sid,userid,issuedate) VALUES ('.$s.','.$id.',"'.date('Ymd').'")' );
    UpdateSectionStats($s);

    $strDefaultStatus=$_POST['status'];
    $strDefaultSection=$s;

    // Unregister global sys (will be recomputed on next page)
    Unset($_SESSION[QT]['sys_members']);
    Unset($_SESSION[QT]['sys_newuserid']);

    // send email
    if ( isset($_POST['notify']) )
    {
    $strSubject='Welcome';
    $strMessage='Please find here after your login and password to access the board '.$_SESSION[QT]['site_name'].PHP_EOL.'Login: %s\nPassword: %s';
    $strFile = GetLang().'mail_registred.php';
    if ( file_exists($strFile) ) include($strFile);
    $strMessage = sprintf($strMessage,$strTitle,$strNewpwd);
    QTmail($strMail,QTconv($strSubject,'-4'),QTconv($strMessage,'-4'),QTE_HTML_CHAR);
    }

    // index
    $oUser = new cUser($id);
    $oUser->SaveKeywords($oUser->GetKeywords(GetFields('index_p')));
    
    // exit
    unset($_POST['title']);
    unset($_POST['pass']);
    $strInfo = $L['Register_completed'];
  }
}

// INITIALISE

$oVIP->selfname = '<span class="upper">'.$L['Adm_content'].'</span><br />'.$L['Users'];

$strGroup = 'all';
$intLimit = 0;
$intPage  = 1;
$strOrder = 'username';
$strDirec = 'ASC';
$strInver = 'DESC';
$strCateg = 'all';

// security check 1
if ( isset($_GET['group']) ) $strGroup = strip_tags($_GET['group']);
if ( isset($_GET['page']) ) $intPage = intval(strip_tags($_GET['page']));
if ( isset($_GET['order']) ) $strOrder = strip_tags($_GET['order']);
if ( isset($_GET['dir']) ) $strDirec = strip_tags($_GET['dir']);
if ( isset($_GET['cat']) ) $strCateg = strip_tags($_GET['cat']);

// security check 2 (no long argument)
if ( strlen($strGroup)>4 ) die('Invalid argument #group');
if ( strlen($strOrder)>12 ) die('Invalid argument #order');
if ( strlen($strDirec)>4 ) die('Invalid argument #dir');

$intLimit = ($intPage-1)*20;
if ( $strDirec=='DESC' ) $strInver='ASC';

$strDataCommand = strtolower($L['Selection']).': <a class="datasetcontrol" onclick="datasetcontrol_click(\'status\'); return false;" href="">'.strtolower($L['Change_status']).'</a> &middot; <a class="datasetcontrol" onclick="datasetcontrol_click(\'delete\'); return false;" href="">'.strtolower($L['Delete']).'</a>
';

// --------
// HTML START
// --------

$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript" src="bin/qte_table.js"></script>
<script type="text/javascript">
<!--
$(function() {
  $("#title").blur(function() {
    $.post("qte_j_exists.php",
    {f:"username",v:$("#title").val(),e1:"'.$L['E_min_4_char'].'",e2:"'.$L['E_already_used'].'"},
    function(data)
    { 
     if ( data.length>0 ) document.getElementById("title_err").innerHTML=data;
    }
    );
    });
  $("#checkboxgroup").click(function() { qtCheckboxAll(this.id,"user[]",true); }); // false  when no row hightlight
  //$(".checkboxuser").click(function() { qtHighlight("tr_"+this.id,this.checked); });   // delete when no row hightlight
  
  // SHIFT-CLICK CHECKBOX

  var lastChecked = null;
  $(".checkboxuser").click(function(event) {
    if(!lastChecked)
    { 
      lastChecked = this;
      qtHighlight("tr_"+this.id,this.checked);
      return;
    }
    if(event.shiftKey)
    {
      var start = $("input[name=\'user[]\']").index(this);
      var end = $("input[name=\'user[]\']").index(lastChecked);
      for(i=Math.min(start,end);i<=Math.max(start,end);i++)
      {
      $(".checkboxuser")[i].checked = lastChecked.checked;
      qtHighlight("tr_"+$(".checkboxuser")[i].id,lastChecked.checked);
      }
    }
    lastChecked = this;
    qtHighlight("tr_"+this.id,this.checked);
  });

});

function datasetcontrol_click(action)
{
  document.getElementById("action").value=action;
  document.getElementById("form_user").submit();
  return;
}

-->
</script>
';

include('qte_adm_p_header.php');

// --------
// Global statistics  (children and children without agreement)
// --------

$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE id>0');
$row = $oDB->Getrow();
$intUsers = $row['countid'];

if ( $_SESSION[QT]['register_coppa']=='1' )
{
  // children (all), children (without agreement only)
  $oDB->Query('SELECT count(id) as numuser FROM '.TABUSER.' WHERE id>1 AND children<>"0"');
  $row = $oDB->Getrow();
  $intChild = $row['numuser'];
  $oDB->Query('SELECT count(id) as numuser FROM '.TABUSER.' WHERE id>1 AND children="2"');
  $row = $oDB->Getrow();
  $intSleepchild = $row['numuser'];

  echo '<table class="data_o" style="width:500px" cellspacing="0">',PHP_EOL;
  echo '<tr class="tr">',PHP_EOL;
  echo '<td class="colgroup">',$L['Users'],'</td>',PHP_EOL;
  echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
  echo '<td class="colgroup"><b>',$intUsers,'</b></td>',PHP_EOL;
  echo '<td class="colgroup">',($strCateg=='all' ? '&nbsp;' : '<a href="qte_adm_users.php">[&raquo;]</a>'),'</td>',PHP_EOL;
  echo '</tr>',PHP_EOL;
  echo '<tr class="tr">',PHP_EOL;
  echo '<td class="colct">',$L['Members_CH'],'</td>',PHP_EOL;
  echo '<td class="colct"><span class="small">',$L['H_Members_CH'],'</span></td>',PHP_EOL;
  echo '<td class="colct"><b>',$intChild,'</b></td>',PHP_EOL;
  echo '<td class="colct">',($intChild>0 && $strCateg!='CH' ? '<a href="qte_adm_users.php?cat=CH">[&raquo;]</a>' : '&nbsp;'),'</td>',PHP_EOL;
  echo '</tr>',PHP_EOL;
  echo '<tr class="tr">',PHP_EOL;
  echo '<td class="colct">',$L['Members_SC'],'</td>',PHP_EOL;
  echo '<td class="colct"><span class="small">',$L['H_Members_SC'],'</span></td>',PHP_EOL;
  echo '<td class="colct"><b>',$intSleepchild,'</b></td>',PHP_EOL;
  echo '<td class="colct">',($intSleepchild>0 && $strCateg!='SC' ? '<a href="qte_adm_users.php?cat=SC">[&raquo;]</a>' : '&nbsp;'),'</td>',PHP_EOL;
  echo '</tr>',PHP_EOL;
  echo '</table><br />',PHP_EOL;

}
else
{
  echo '<p>'.$intUsers.' '.$L['Users'].'</p>';
}

// --------
// Category subform
// --------

if ( $strCateg!='all' )
{
  echo '<h1>',$L['Members_'.$strCateg],' (',$L['H_Members_'.$strCateg],')</h1>',PHP_EOL;
}

// --------
// Button line and pager
// --------

Switch ($strGroup)
{
  Case 'all': $strWhere = ' WHERE id>0'; Break;
  Case '0':   $strWhere = ' WHERE '.FirstCharCase('username','a-z'); Break;
  Default:    $strWhere = ' WHERE '.FirstCharCase('username','u').'="'.$strGroup.'"'; Break;
}

if ( $strCateg=='CH' ) $strWhere .= ' AND id>1 AND children<>"0"'; //children
if ( $strCateg=='SC' ) $strWhere .= ' AND id>1 AND children="2"';  //sleeping children

$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.$strWhere);
$row = $oDB->Getrow();
$intCount = $row['countid'];

// -- build pager --

$strPager = MakePager("qte_adm_users.php?cat=$strCateg&group=$strGroup&order=$strOrder&dir=$strDirec",$intCount,20,$intPage);
if ( !empty($strPager) ) { $strPager = $L['Page'].$strPager; } else { $strPager=S; }
if ( $intCount<$intUsers ) $strPager = '<span class="small">'.$intCount.' '.$L['Selected_from'].' '.$intUsers.' '.strtolower($L['Users']).'</span>'.($strPager==S ? '' : ' | '.$strPager);

// -- Display button line and pager --

if ( $intCount>20 || $strGroup!='all' ) echo '<table class="lettres" cellspacing="0"><tr class="lettres">',( $strCateg=='all' ? HtmlLettres($strGroup,null,$L['All']) : '' ),'</tr></table>',PHP_EOL;

// --------
// Memberlist
// --------

if ( $intCount!=0 )
{

  $img['NO']='';
  $img['ASC']= ' <img class="ico i_sort" src="admin/sort_asc.gif" alt="+"/>';
  $img['DESC']= ' <img class="ico i_sort" src="admin/sort_desc.gif" alt="-"/>';
  $sort['ASC']= 'DESC';
  $sort['DESC']= 'ASC';
  
  echo '<form id="form_user" method="post" action="',$oVIP->selfurl,'"><input type="hidden" name="action" id="action" value="0" />',PHP_EOL;
  
  echo '<table class="hidden" cellspacing="0" ><tr>',($intCount<3 ? '' : '<td class="pager_zt"><img src="admin/selection_up.gif" style="width:10px;height:10px;vertical-align:bottom;margin:0 10px 0 13px"/>'.$strDataCommand.'</td>'),'<td class="pager_zt right">',$strPager,'</td></tr></table>',PHP_EOL;

  echo '<table class="data_t" cellspacing="0">',PHP_EOL;
  echo '<tr>',PHP_EOL;
  echo '<td class="colhd" style="width:25px;"><input type="checkbox" id="checkboxgroup" class="checkboxgroup"',($intCount<3 ? ' style="display:none"' : ''),' /></td>',PHP_EOL;
  if ( $intCount>2 )
  {
    echo '<td class="colhd center" style="width:25px"><a class="colhd" href="qte_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=status&amp;dir=' , $sort[$strDirec] , '">&bull;</a>' , ($strOrder=='status' ? $img[$strDirec] : $img['NO']) , '</td>',PHP_EOL;
    echo '<td class="colhd"><a class="colhd" href="qte_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=username&amp;dir=' , $sort[$strDirec] , '">', ObjTrans('field','username'), '</a>' , ($strOrder=='username' ? $img[$strDirec] : $img['NO']) , '</td>',PHP_EOL;
    echo '<td class="colhd"><a class="colhd" href="qte_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=fullname&amp;dir=' , $sort[$strDirec] , '">',ObjTrans('field','fullname'),'</a>' , ($strOrder=='fullname' ? $img[$strDirec] : $img['NO']) , '</td>',PHP_EOL;
    echo '<td class="colhd"><a class="colhd" href="qte_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=role&amp;dir=' , $sort[$strDirec] , '">' , $L['Role'] , '</a>' , ($strOrder=='role' ? $img[$strDirec] : $img['NO']) , '</td>',PHP_EOL;
    echo '<td class="colhd"><a class="colhd" href="qte_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=firstdate&amp;dir=' , $sort[$strDirec] , '">' , $L['Registration'] , '</a>' , ($strOrder=='firstdate' ? $img[$strDirec] : $img['NO']) , '</td>',PHP_EOL;
    echo '<td class="colhd center" style="width:35px;"><a class="colhd" href="qte_adm_users.php?cat=',$strCateg,'&amp;group=',$strGroup,'&amp;page=1&amp;order=id&amp;dir=' , $sort[$strDirec] , '">Id</a>' , ($strOrder=='id' ? $img[$strDirec] : $img['NO']) , '</td>',PHP_EOL;
  }
  else
  {
    echo '<td class="colhd center" style="width:25px">&bull;</td>',PHP_EOL;
    echo '<td class="colhd">',ObjTrans('field','username'),'</td>',PHP_EOL;
    echo '<td class="colhd">',ObjTrans('field','fullname'),'</td>',PHP_EOL;
    echo '<td class="colhd">',$L['Role'],'</td>',PHP_EOL;
    echo '<td class="colhd">',$L['Registration'],'</td>',PHP_EOL;
    echo '<td class="colhd center" style="width:35px;">Id</td>',PHP_EOL;
  }
  echo '</tr>',PHP_EOL;

  //-- LIMIT QUERY --
  $strState = 'id,username,status,role,title,firstname,midname,lastname,alias,ip,firstdate FROM '.TABUSER.$strWhere;
  if ( $strOrder=='fullname' ) $strOrder = 'lastname';
  $oDB->Query( LimitSQL($strState,$strOrder.' '.$strDirec,$intLimit,20) );
  // --------
  
  $bEndCommands=false;
  while($row=$oDB->Getrow())
  {
    $oUser = new cUser($row);
    echo '<tr class="rowlight" id="tr_user'.$oUser->id.'">',PHP_EOL;
    echo '<td class="colct">';
    if ($oUser->id>1) { $bEndCommands=true; echo '<input type="checkbox" class="checkboxuser" name="user[]" id="user'.$oUser->id.'" value="'.$oUser->id.'" onclick="qtCheckboxOne(\'user[]\',\'checkboxgroup\');" />'; } else { echo '&nbsp;'; }
    echo '</td>',PHP_EOL;
    echo '<td class="colct center"><label for="user'.$oUser->id.'">',(isset($oVIP->statuses[$oUser->status]) ? AsImg($_SESSION[QT]['skin_dir'].'/'.$oVIP->statuses[$oUser->status]['icon'],$oUser->status,$oVIP->statuses[$oUser->status]['statusname'],'ico i_status') : '&nbsp;'),'</label></td>',PHP_EOL;
    echo '<td class="colct"><a href="',Href('qte_user.php'),'?id=',$oUser->id,'">',$oUser->username,'</a></td>',PHP_EOL;
    echo '<td class="colct small"><label for="user'.$oUser->id.'">',$oUser->fullname,'</label></td>',PHP_EOL;
    echo '<td class="colct small"><label for="user'.$oUser->id.'">',$L['Userrole'][$oUser->role],'</label></td>',PHP_EOL;
    echo '<td class="colct small"><label for="user'.$oUser->id.'">',(!empty($oUser->firstdate) ? QTdatestr($oUser->firstdate,'$','') : S),'</label></td>',PHP_EOL;
    echo '<td class="colct small center"><label for="user'.$oUser->id.'">',$oUser->id.'</label></td>',PHP_EOL;
    echo '</tr>',PHP_EOL;
  }
  echo '</table>',PHP_EOL;

  echo '<table class="hidden" cellspacing="0"><tr class="hidden">',($bEndCommands ? '<td class="pager_zb"><img src="admin/selection_down.gif" style="width:10px;height:10px;vertical-align:top;margin:0 10px 0 13px"/>'.$strDataCommand.'</td>' : ''),'<td class="pager_zb right">',$strPager,'</td></tr></table>',PHP_EOL;
  echo '</form>',PHP_EOL;

}
else
{
  TableEmpty($L['E_no_member'].'...');
}

// --------
// Form
// --------

if ( !isset($strDefaultStatus) ) $strDefaultStatus='Z';

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': ',ObjTrans('field','username'),'")); return false; }
  if (theForm.pass.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': ',$L['Password'],'")); return false; }
  if (theForm.mail.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': ',$L['Email'],'")); return false; }
  return null;
}
-->
</script>
';

echo '<h2>',$L['Sysuser_add'],'</h2>',PHP_EOL;
echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">',PHP_EOL;
echo '<table class="data_o" cellspacing="0">',PHP_EOL;
echo '<tr class="data_o">',PHP_EOL;
echo '<td class="colhd" style="text-align:left">',$L['Status'],'</td>',PHP_EOL;
echo '<td class="colhd" style="text-align:left">',ObjTrans('field','username'),'</td>',PHP_EOL;
echo '<td class="colhd" style="text-align:left">',$L['Password'],'</td>',PHP_EOL;
echo '<td class="colhd" style="text-align:left">',$L['Email'],'</td>',PHP_EOL;
echo '</tr>',PHP_EOL;
echo '<tr class="data_o">',PHP_EOL;
echo '<td class="colct col_inf"><select name="status" size="1">',QTasTag($oVIP->statuses,$strDefaultStatus),'</select></td>',PHP_EOL;
echo '<td class="colct col_inf"><input id="title" name="title" type="text" size="20" maxlength="24" value="',(isset($_POST['title']) ? $_POST['title'] : ''),'" onfocus="document.getElementById(\'title_err\').innerHTML=\'\';" /></td>',PHP_EOL;
echo '<td class="colct col_inf"><input id="pass" name="pass" type="text" size="24" maxlength="32"  value="',(isset($_POST['pass']) ? $_POST['pass'] : ''),'" /></td>',PHP_EOL;
echo '<td class="colct col_inf"><input id="mail" name="mail" type="text" size="24" maxlength="255"  value="',(isset($_POST['mail']) ? $_POST['mail'] : ''),'" /></td>',PHP_EOL;
echo '</tr>',PHP_EOL;
echo '<tr class="data_o">',PHP_EOL;
echo '<td class="colgroup" colspan="4" style="text-align:right">
',$L['In_section'],' <select name="s" size="1">',Sectionlist($s),'</select>
 <input id="notify" name="notify" type="checkbox" /> <label for="notify">'.$L['Send'].' '.strtolower($L['Email']).'</label>&nbsp; <input type="submit" id="add" name="add" value="',$L['Add'],'" />
</td>',PHP_EOL;
echo '</tr>',PHP_EOL;
echo '</table>
<span id="title_err" class="error"></span>
</form>
';
if ( !empty($error) ) echo '<span class="error">',$error,'</span><br />',PHP_EOL;
echo '<p><a href="qte_adm_users_imp.php">',$L['Users_import_csv'],'</a></p>';

// --------
// HTML END
// --------

include('qte_adm_p_footer.php');