<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
if ( !$oVIP->CanView('M') ) die(Error(12));

// ---------
// INITIALISE
// ---------

include(Translate('qte_adm.php'));

$oVIP->selfurl = 'qte_adm_users_move.php';
$oVIP->selfname = $L['User_man'];
$oVIP->exiturl  = 'qte_adm_sections.php';
$oVIP->exitname = '&laquo; '.$L['Sections'];

$s = -1;
$n = 'lf';
QThttpvar('s n','int str');

if ( $s<0 ) die('Wrong id in '.$oVIP->selfurl);
// name display: l=lastname, f=firstnamen, u=username
// ex: lf, lfu, ulf
$strFirstname = ObjTrans('field','firstname');
$strLastname = ObjTrans('field','lastname');
$strUsername = ObjTrans('field','username');
$arrN = array('lf'=>"$strLastname $strFirstname",'lfu'=>"$strLastname $strFirstname ($strUsername)",'fl'=>"$strFirstname $strLastname",'flu'=>"$strFirstname $strLastname ($strUsername)",'u'=>"$strUsername",'ulf'=>"$strUsername ($strLastname $strFirstname)",'ufl'=>"$strUsername ($strFirstname $strLastname)");
if ( !array_key_exists($n,$arrN) ) die('Wrong parameter n');

$strShowsection = 'all'; if ( isset($_POST['showsection']) ) $strShowsection =$_POST['showsection'];
$strShowusers = 'all'; if ( isset($_POST['showusers']) ) $strShowusers = $_POST['showusers'];
$strMoveInfo = '';

$oSEC = new cSection($s);
if ( $oSEC->status==1 && $oVIP->role=='M' ) die(Error(13));

// --------
// SUBMITTED
// --------

if ( isset($_POST['add']) && isset($_POST['sec_add']) )
{
  $i = 0;
  foreach($_POST['sec_add'] as $intKey)
  {
  if ( cUser::InSection($s,'add',$intKey) ) $i++;
  }
  if ( $i>1 ) 
  {
  $strMoveInfo .= $i.' '.sprintf($L['Members_added'],$oSEC->name);
  }
  else
  {
  $strMoveInfo .= $i.' '.sprintf($L['Member_added'],$oSEC->name);
  }
  $oSEC->stats = UpdateSectionStats($s);
  $oSEC->ReadStats();
}
if ( isset($_POST['rem']) && isset($_POST['sec_del']) )
{
  $i = 0;
  foreach($_POST['sec_del'] as $intKey)
  {
  if ( cUser::InSection($s,'rem',$intKey) ) $i++;
  }
  if ( $i>1 ) 
  {
  $strMoveInfo .= $i.' '.sprintf($L['Members_removed'],$oSEC->name);
  }
  else
  {
  $strMoveInfo .= $i.' '.sprintf($L['Member_removed'],$oSEC->name);
  }
  $oSEC->stats = UpdateSectionStats($s);
  $oSEC->ReadStats();
}

// --------
// LISTS
// --------

// list users (section)

$arr = array();
switch($strShowsection)
{
case 'A': $arr = GetUsers('A',$s); break;
case 'M': $arr = GetUsers('M-',$s); break;
case 'U': $arr = GetUsers('U',$s); break;
default : $arr = GetUsers('all',$s); break;
}
$arrShowsection = FormatUsers($arr,$n); // format the result according to $n

// list users (all/filtered)

$arr = array();
switch($strShowusers)
{
case 'all': $arr = GetUsers('all',-1); break;
case 'A': $arr = GetUsers('A',-1); break;
case 'M': $arr = GetUsers('M-',-1); break;
case 'U': $arr = GetUsers('U',-1); break;
case 'lost': $arr = GetUsers('lost',-1); break;
default :
  if ( is_numeric($strShowusers) ) {
  if ( $strShowusers>=0 ) {
    $arr = GetUsers('all',(int)$strShowusers);
  }}
  break;
}
$arrShowusers = FormatUsers($arr,$n);

// list sections

$arr = GetSectionTitles('A',-1,$s); // list of other teams (attention, key id must be string)
$arrSections = array();
foreach ($arr as $intKey => $strValue)
{
$arrSections['S'.$intKey]=$strValue;
}

// --------
// HTML START
// --------

$strStatuses='';
foreach($oVIP->statuses as $key=>$arr) $strStatuses .= 'var status_'.$key.'="'.(isset($arr['statusname']) ? $arr['statusname'] : 'null' ).'"; var icon_'.$key.'="'.(isset($arr['icon']) ? $arr['icon'] : 'null' ).'";'.PHP_EOL;

$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript">
<!--
$(function() {
  $("#sec_del,#sec_add").change(function() {
    $.post("qte_j_user.php",
     {id:this.value},
     function(data)
     { 
     if ( data.length>0 ) document.getElementById("title_err").innerHTML=addstatus(data);
     }
    );
  });
});

function addstatus(data)
{
var i = data.lastIndexOf("<status ");
if ( i<0 ) return data;
var status = data.substr(i+8,1);
'.$strStatuses.'
return data.replace("<status "+status+"/>", "<p class=\"small\"><img src=\"'.$_SESSION[QT]['skin_dir'].'/" + eval("icon_"+status) + "\" alt=\"" + status + "\" style=\"vertical-align:middle\" /> " + eval("status_"+status) + "</p>");
}

-->
</script>
';

include('qte_adm_p_header.php');

$oSEC->descr .= (empty($oSEC->descr) ? '' : '<br />' ).'<span class="small">('.LangS('User',$oSEC->members).')</span>';
echo '<div style="height:100px; overflow:hidden;margin-bottom:5px">',$oSEC->ShowInfo('sectioninfo_left','sectioninfo','sectiondesc'),'</div>',PHP_EOL;

// -- DISPLAY --

echo '<form method="post" action="',$oVIP->selfurl,'?s=',$s,'">
<input type="hidden" id="s" name="s" value="',$s,'"/>
<p class="right" style="margin:2px 0 5px 0">',$L['Display_order'],': <select class="small" id="n" name="n" onchange="document.getElementById(\'nameformat\').click();">',QTasTag($arrN,$n),'</select><input type="submit" id="nameformat" name="nameformat" value="',$L['Ok'],'" class="small"/></p>
<script type="text/javascript">document.getElementById("nameformat").style.display="none";</script>

<table class="data_s" cellspacing="0">
<colgroup span="3"><col width="260"></col><col width="260"></col><col></col></colgroup>
';
echo '<tr style="vertical-align:top">
<td class="colhd">',$L['Section_members'],'</td>
<td class="colhd">',$L['Registered_members'],'</td>
<td class="colhd">Info</td>
</tr>
';

echo '<tr style="vertical-align:top">';

// COL 1: Section

echo '<td class="colct" style="padding:0 0 6px 6px; background-color:#FFFF99">';
echo '<span class="small">',$L['Show'],':</span><br />';
echo '<select name="showsection" id="showsection" size="1" class="small" style="width:225px" onchange="document.getElementById(\'filtersection\').click();">';
echo '<option class="small" value="all"',($strShowsection=='all' ? QSEL : ''),'>',$L['Users_section'],'</option>';
echo '<option class="small" value="-" disabled="disabled">------------------</option>';
echo '<option class="small" value="A"',($strShowsection=='A' ? QSEL : ''),'>',$L['Userroles']['A'],'</option>';
echo '<option class="small" value="M"',($strShowsection=='M' ? QSEL : ''),'>',$L['Userroles']['M'],'</option>';
echo '</select><input type="submit" id="filtersection" name="filtersection" value="',$L['Ok'],'" class="small"/>
<script type="text/javascript">document.getElementById("filtersection").style.display="none";</script>
<br /><br />',PHP_EOL;
echo '<select name="sec_del[]" id="sec_del" size="20" class="small" style="width:225px" multiple="multiple">';
echo QTasTag($arrShowsection,'',array('class'=>'small'));
echo '</select><br /><br />',PHP_EOL;
if ( $oSEC->members>0 ) echo '<input type="submit" id="rem" name="rem" value="',$L['User_section_del'],' &gt;" style="width:220px"/><br /><br />';
if ( $oSEC->members==0 || $s==0 )
{
echo '<span class="disabled">'.$L['Members_moveall'].'...</span>',PHP_EOL;
}
else
{
echo '<a href="qte_change.php?a=moveallmembers&amp;s='.$s.'&amp;exit2" class="small">'.$L['Members_moveall'].'...</a>',PHP_EOL;
}
echo '</td>',PHP_EOL;

// COL 2: All users

echo '<td class="hidden" style="padding-left:6px">',PHP_EOL;
echo '<span class="small">',$L['Show'],':</span><br />';
echo '<select name="showusers" id="showusers" size="1" class="small" style="width:225px" onchange="document.getElementById(\'filtermembers\').click();">';
echo '<option class="small" value="all"',($strShowusers==='all' ? QSEL : ''),'>',$L['Users_reg'],'</option>';
echo '<option class="small" value="-" disabled="disabled">------------------</option>';
echo Sectionlist($strShowusers,$s);
echo '<option class="small" value="-" disabled="disabled">------------------</option>';
echo '<option class="small" value="lost"',($strShowusers==='lost' ? QSEL : ''),'>',$L['Users_not_in_team'],'</option>';
echo '<option class="small" value="A"',($strShowusers==='A' ? QSEL : ''),'>',$L['Userroles']['A'],'</option>';
echo '<option class="small" value="M"',($strShowusers==='M' ? QSEL : ''),'>',$L['Userroles']['M'],'</option>';
echo '</select><input type="submit" id="filtermembers" name="filtermembers" value="',$L['Ok'],'" class="small"/>
<script type="text/javascript">document.getElementById("filtermembers").style.display="none";</script>
<br /><br />',PHP_EOL;
echo '<select name="sec_add[]" id="sec_add" size="20" class="small" style="width:225px" multiple="multiple">';
echo QTasTag($arrShowusers,'',array('class'=>'small'));
echo '</select><br /><br />',PHP_EOL;
echo '<input type="submit" id="add" name="add" value="&lt; ',$L['User_section_add'],'" style="width:220px"/><br /><br />',PHP_EOL;
echo '</td>',PHP_EOL;

// COL 3: Preview/Info

echo '<td class="hidden" style="padding:6px">';

  // DISPLAY Preview
  echo '<p style="font-weight:bold;color:#555555">',$L['Selected_user'],'</p>';
  if ( !empty($strMoveInfo) ) echo '<p id="infomessage"style="color:#007F11">'.$strMoveInfo.'</p>';
  echo '<script type="text/javascript"></script><noscript class="small">No preview...<br />Your browser does not support JavaScript</noscript>';
  echo '<p id="title_err"></p>',PHP_EOL;  
  
echo '</td>',PHP_EOL;

// END COL

echo '</tr>
</table>
</form>
';

if ( $s==0 ) echo '<p class="small">'.$L['H_Moving_0'].'</p>';

// animation of the infomessage (errors remains on screen)
if ( !empty($strMoveInfo) ) 
{
echo '
<script type="text/javascript">
<!--
setTimeout(\'document.getElementById("infomessage").style.color="#bbbbbb"\',3000);
setTimeout(\'document.getElementById("infomessage").style.color="#cccccc"\',3300);
setTimeout(\'document.getElementById("infomessage").style.color="#dddddd"\',3600);
setTimeout(\'document.getElementById("infomessage").innerHTML="&nbsp;"\',3900);
-->
</script>
';
}

// --------
// HTML END
// --------

if ( !$bShowtoc ) { $oVIP->exiturl='qte_index.php'; $oVIP->exitname=ObjTrans('index','i',$_SESSION[QT]['index_name']); }

echo '<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a> &middot; ',$L['Goto'],' <a href="qte_members.php?s=',$oSEC->id,'" target="_top">',$oSEC->name,'</a></p>';

include('qte_adm_p_footer.php');