<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */
 
session_start();
require_once('bin/qte_init.php');
if ( !$oVIP->CanView('V4') ) die(Error(11));

// --------
// INITIALISE
// --------

$v = 'birthdate';
$intYear   = intval(date('Y'));
if ( isset($_GET['y']) ) $intYear = intval(strip_tags($_GET['y']));
$intYearN  = $intYear;
$intMonth  = intval(date('n'));
if ( isset($_GET['m']) ) $intMonth = intval(strip_tags($_GET['m']));
$intMonthN = $intMonth+1; if ( $intMonthN>12 ) { $intMonthN=1; $intYearN++; }
$strMonth  = '0'.$intMonth; $strMonth = substr($strMonth,-2,2);
$strMonthN = '0'.$intMonthN; $strMonthN = substr($strMonthN,-2,2);

$arrEvents = array();
$arrEventsN = array();
$intEvents = 0;
$intEventsN = 0;

if ( $intYear>2100 ) die('Invalid year');
if ( $intYear<1900 ) die('Invalid year');
if ( $intMonth>12 ) die('Invalid month');
if ( $intMonth<1 ) die('Invalid month');

$oVIP->selfurl = 'qte_cal_list.php';
$oVIP->selfname = $L['Calendar'];
$oVIP->exiturl = 'qte_calendar.php?y='.$intYear.'&amp;m='.$intMonth;
$oVIP->exitname = '&laquo; '.$L['Calendar'];

// --------
// HTML START
// --------

$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qte_main2.css" title="cssmain" />';

include('qte_p_header.php');

// USERS

switch($oDB->type)
{
// Select month
case 'mysql4':
case 'mysql':
case 'sqlsrv':
case 'mssql':
case 'pg': $oDB->Query( 'SELECT id,username,title,firstname,midname,lastname,emails,alias,picture,'.$v.' FROM '.TABUSER.' WHERE SUBSTRING('.$v.',5,2)="'.$strMonth.'" OR SUBSTRING('.$v.',5,2)="'.$strMonthN.'"' ); break;
case 'ibase': $oDB->Query( 'SELECT id,username,title,firstname,midname,lastname,emails,alias,picture,'.$v.' FROM '.TABUSER.' WHERE SUBSTRING('.$v.' FROM 5 FOR 2)="'.$strMonth.'" OR SUBSTRING('.$v.' FROM 5 FOR 2)="'.$strMonthN.'"' ); break;
case 'sqlite':
case 'db2':
case 'oci': $oDB->Query( 'SELECT id,username,title,firstname,midname,lastname,emails,alias,picture,'.$v.' FROM '.TABUSER.' WHERE SUBSTR('.$v.',5,2)="'.$strMonth.'" OR SUBSTR('.$v.',5,2)="'.$strMonthN.'"' ); break;
default: die('Unknown db type '.$oDB->type);
}
while($row=$oDB->Getrow())
{
  if ( strlen($row[$v])==8 )
  {
    $strM = substr($row[$v],4,2); $intM = intval($strM);
    $strD = substr($row[$v],6,2); $intD = intval($strD);
    if ( $strM==$strMonth ) { $arrEvents[$intD][]=$row; $intEvents++; }
    if ( $strM==$strMonthN ) { $arrEventsN[$intD][]=$row; $intEventsN++; }
  }
}
ksort($arrEvents);
ksort($arrEventsN);

echo '<h1>',$L['Birthdays_calendar'],' ',$L['dateMMM'][$intMonth],' ',$intYear,'</h1>',PHP_EOL;

echo '<table class="data_t" cellspacing="0">',PHP_EOL;  
echo '<colgroup span="5"><col width="40"></col><col width="210"></col><col width="150"></col><col></col><col width="150"></col></colgroup>',PHP_EOL;
echo '<tr class="data_t">',PHP_EOL;
echo '<td class="colhd colhdfirst colhdempty"></td>',PHP_EOL;
echo '<td class="colhd colhdempty"></td>',PHP_EOL;
echo '<td class="colhd colhdempty"></td>',PHP_EOL;
echo '<td class="colhd colhdempty"></td>',PHP_EOL;
echo '<td class="colhd colhdlast colhdempty"></td>',PHP_EOL;
echo '</tr>',PHP_EOL;

if ( count($arrEvents)==0 )
{
  echo '<tr class="tr_t"><td class="colct" colspan="4">',$L['None'],'</td>';
}
else
{
  foreach ($arrEvents as $intDay => $arrEvent) {
  foreach ($arrEvent as $intNum => $arrUser) {
  $oUser = new cUser($arrUser,true); // privatise
  echo '<tr class="tr_t">';
  echo '<td class="colct"><p class="datenumber">',$intDay,'</p></td>';
  echo '<td class="colct"><a href="',Href('qte_user.php'),'?id=',$oUser->id,'" title="',$oUser->fullname,'">',$oUser->fullname,'</a>',(empty($oUser->age) ? '' : ' ('.$oUser->age.')'),'</td>';
  echo '<td class="colct center">',QTdatestr($oUser->birthdate,'$','',true),'</td>';
  $arr = AsList($oUser->emails,$_SESSION[QT]['viewmode']=='C');
  foreach($arr as $intKey=>$strValue)
  {
  $arr[$intKey] = AsEmailImage(trim($strValue),'mail_'.$oUser->id.'_'.$intKey,true,QTE_JAVA_MAIL,array('class'=>'small'));
  }
  $str = implode(' ',$arr);
  echo '<td class="colct center">',$str,'</td>';
  echo '<td class="colct center">',( empty($oUser->picture) ? S : AsImg($oUser->picture,'',$oUser->fullname,'','height:35px;','qte_user.php?id='.$oUser->id) ),'</td>';
  echo '</tr>',PHP_EOL;
  }}
}
echo '<tr class="colft">',PHP_EOL;
echo '<td class="colft colftfirst"></td>',PHP_EOL;
echo '<td class="colft"></td>',PHP_EOL;
echo '<td class="colft"></td>',PHP_EOL;
echo '<td class="colft"></td>',PHP_EOL;
echo '<td class="colft colftlast"></td>',PHP_EOL;
echo '</tr>',PHP_EOL;
echo '</table><br />',PHP_EOL;

echo '<h1>',$L['Birthdays_calendar'],' ',$L['dateMMM'][$intMonthN],' ',$intYearN,'</h1>',PHP_EOL;

echo '<table class="data_t" cellspacing="0">',PHP_EOL;  
echo '<colgroup span="5"><col width="40"></col><col width="210"></col><col width="150"></col><col></col><col width="150"></col></colgroup>',PHP_EOL;
echo '<tr class="data_t">',PHP_EOL;
echo '<td class="colhd colhdfirst colhdempty"></td>',PHP_EOL;
echo '<td class="colhd colhdempty"></td>',PHP_EOL;
echo '<td class="colhd colhdempty"></td>',PHP_EOL;
echo '<td class="colhd colhdempty"></td>',PHP_EOL;
echo '<td class="colhd colhdlast colhdempty"></td>',PHP_EOL;
echo '</tr>',PHP_EOL;

if ( count($arrEventsN)==0 )
{
  echo '<tr class="tr_t"><td class="colct" colspan="4">',$L['None'],'</td>';
}
else
{
  foreach ($arrEventsN as $intDay => $arrEvent) {
  foreach ($arrEvent as $intNum => $arrUser) {  
    $oUser = new cUser($arrUser,true); // privatise
    echo '<tr class="tr_t">';
    echo '<td class="colct"><p class="datenumber">',$intDay,'</p></td>';
    echo '<td class="colct"><a href="',Href('qte_user.php'),'?id=',$oUser->id,'" title="',$oUser->fullname,'">',$oUser->fullname,'</a>',(empty($oUser->age) ? '' : ' ('.$oUser->age.')'),'</td>';
    echo '<td class="colct center">',QTdatestr($oUser->birthdate,'$','',true),'</td>';
    $arr = AsList($oUser->emails,$_SESSION[QT]['viewmode']=='C');
    foreach($arr as $intKey=>$strValue)
    {
    $arr[$intKey] = AsEmailImage(trim($strValue),'mail_'.$oUser->id.'_'.$intKey,true,QTE_JAVA_MAIL,array('class'=>'small'));
    }
    $str = implode(' ',$arr);
    echo '<td class="colct center">',$str,'</td>';
    echo '<td class="colct center">',AsImg($oUser->picture,'',$oUser->fullname,'','height:35px;','qte_user.php?id='.$oUser->id),'</td>';
    echo '</tr>',PHP_EOL;
  }}
}
echo '<tr class="data_t">',PHP_EOL;
echo '<td class="colft colftfirst"></td>',PHP_EOL;
echo '<td class="colft"></td>',PHP_EOL;
echo '<td class="colft"></td>',PHP_EOL;
echo '<td class="colft"></td>',PHP_EOL;
echo '<td class="colft colftlast"></td>',PHP_EOL;
echo '</tr>',PHP_EOL;
echo '</table><br />',PHP_EOL;


// HTML END

echo '<br /><a href="',Href($oVIP->exiturl),'">',$oVIP->exitname,'</a><br /><br />',PHP_EOL;

include('qte_p_footer.php');