<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
include('bin/qt_lib_smtp.php');

// ---------
// INITIALISE
// ---------

$a = ''; // mandatory action
$d = -1; // domain (or destination)
$s = -1; // section
$u = -1; // id (user id)
$v = ''; // value
$ok = ''; // submitted
QThttpvar('a d s u v ok','str int int int str str',true,true,false); // reject POST method

include(Translate('qte_adm.php'));

$bCmdok = false;
$strMails = '';

$oVIP->selfurl  = 'qte_change.php';
$oVIP->selfname = 'QuickTeam command';

// --------
// EXECUTE COMMAND
// --------

switch($a)
{
// --------------
case 'deletesection':
// --------------

  if ( $oVIP->role!='A' ) die($L['R_admin']);
  if ( $s<1 ) die('Wrong id in '.$oVIP->selfurl);

  $oVIP->selfname = $L['Section_del'];
  $oVIP->exiturl  = 'qte_adm_sections.php';
  $oVIP->exitname = '&laquo; '.$L['Sections'];

  $oSEC = new cSection($s);

  // ask confirmation
  if ( empty($ok) )
  {
    // list content
    if ( $oSEC->members>0 )
    {
      $arrDest = array(); // array_diff_key() not supported in php<5.1      
      foreach ($oVIP->sections as $intKey => $strValue) { if ( $intKey!=$s ) $arrDest[$intKey] = $strValue; }
      
      $strList = '<tr class="tr">
      <td class="colhd colhdfirst">'.$L['Users'].'</td>
      <td class="colct">
      <select name="d" size="1" class="small">'.QTasTag($arrDest,'',array('format'=>$L['Move_to'].': %s')).'</select>
      </td>
      </tr>';
    }
    else
    {
      $strList = '';
    }    

    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table class="data_o" cellspacing="0">
    <tr class="tr">
    <td class="colhd colhdfirst" style="width:150px">'.$L['Section'].'</td>
    <td class="colct">'.$oSEC->name.'</td>
    </tr>
    <tr class="tr">
    <td class="colhd colhdfirst">'.$L['Containing'].'</td>
    <td class="colct">'.LangS('User',$oSEC->members).'</td>
    </tr>
    '.$strList.'
    <tr class="tr">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/>
    </td>
    </tr>
    </table>
    </form>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // move members, delete translations, delete section and unset
  if ( $d<0 ) $d=0;
  cSection::MoveItems($s,$d);
  UpdateSectionStats($s);
  UpdateSectionStats($d);

  cVIP::LangDel(array('sec','secdesc'),'s'.$s);
  $oDB->Query('DELETE FROM '.TABSECTION.' WHERE id='.$s);
  $_SESSION['L'] = array();
  if ( isset($_SESSION[QT]['sys_sections']) ) unset($_SESSION[QT]['sys_sections']);
  
  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'deletedomain':
// --------------

  if ( $oVIP->role!='A' ) die($L['R_admin']);
  if ( $s<1 ) die('Wrong id in '.$oVIP->selfurl);

  $oVIP->selfname = $L['Domain_del'];
  $oVIP->exiturl  = 'qte_adm_sections.php';
  $oVIP->exitname = '&laquo; '.$L['Sections'];

  // ask destination
  if ( empty($ok) )
  {
    $strTitle = $oVIP->domains[$s];
    $arrTeams = GetSectionTitles($oVIP->role,$s);

    // list the domain content
    if ( count($arrTeams)==0 )
    {
      $strDcont = '<span class="small">0 '.$L['Section'].'</span>';
    }
    else
    {
      $strDcont = '';
      foreach ($arrTeams as $intKey => $strValue)
      {
      $strDcont .= '<span class="small">'.$L['Section'].': '.$strValue.'</span><br />';
      }
    }

    // list of domain destination
    if ( count($arrTeams)>0 )
    {
      $arrDest = array(); // array_diff_key() not supported in php<5.1      
      foreach ($oVIP->domains as $intKey => $strValue) { if ( $intKey!=$s ) $arrDest[$intKey] = $strValue; }
      
      $strDest = '<tr class="tr">
      <td class="colhd colhdfirst">'.$L['Sections'].'</td>
      <td class="colct">
      <select name="d" size="1" class="small">'.QTasTag($arrDest,'',array('format'=>$L['Move_to'].': %s')).'</select>
      </td>
      </tr>';
    }    
    else
    {
      $strDest = '';
    }

    // form
    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table class="data_o" cellspacing="0">
    <tr class="tr">
    <td class="colhd colhdfirst" style="width:150px">'.$L['Title'].'</td>
    <td class="colct"><b>'.$strTitle.'</b></td>
    </tr>
    <tr class="tr">
    <td class="colhd colhdfirst">'.$L['Containing'].'</td>
    <td class="colct">'.$strDcont.'</td>
    </tr>'.PHP_EOL.$strDest.'
    <tr class="tr">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/></td>
    </tr>
    </table>
    </form>',      
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // delete domain $s and move content to destination $d
  
  require_once('bin/qte_class_dom.php');
  if ( $d>-1 ) cDomain::MoveItems($s,$d);
  cDomain::Drop($s);

  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'pwdreset':
// --------------

  if ( !$oVIP->IsStaff() ) die($L['R_staff']);
  if ( $u<0 ) die('Wrong id in '.$oVIP->selfurl);

  include(Translate('qte_reg.php'));

  $oVIP->selfname = $L['Reset_pwd'];
  $oVIP->exiturl  = Href('qte_user.php').'?id='.$u;
  $oVIP->exitname = '&laquo; '.$L['Profile'];

  $oUser = new cUser($u);
    
  // ask delay
  if ( empty($ok) )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden">'.AsImgBoxUser($oUser,'username').'</td>
    <td class="hidden">
    <p style="text-align:right">'.$L['Reset_pwd_help'].'<br /><br />'.$oVIP->selfname.'&nbsp;
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="u" value="'.$u.'"/>
    <input type="submit" name="ok" value="'.$L['Send'].'"/></p>
    </td>
    </tr>
    </table></form>',
    'admin',
    0,
    '500px'
    );
    exit;
  }

  // reset user
  $strNewpwd = 'qt'.rand(0,9).rand(0,9).rand(0,9).rand(0,9);
  $oDB->Query('UPDATE '.TABUSER.' SET pwd="'.sha1($strNewpwd).'" WHERE id='.$u);

  // send email
  $strSubject = $_SESSION[QT]['site_name'].' - New password';
  $strMessage = "Here are your login and password\nLogin: %s\nPassword: %s";
  $strFile = GetLang().'mail_pwd.php';
  if ( file_exists($strFile) ) include($strFile);
  $strMessage = sprintf($strMessage,$oUser->username,$strNewpwd);
  QTmail($oUser->emails,QTconv($strSubject,'-4'),QTconv($strMessage,'-4'),QTE_HTML_CHAR);
  $strEndmessage = str_replace("\n",'<br />',$strMessage);

  // parent warning if coppa (and if edited by the kid himself)
  if ( $oUser->coppa != '0' ) {
  if ( $_SESSION[QT]['register_coppa']=='1' ) {
    $oDB->Query('SELECT parentmail FROM '.TABCHILD.' WHERE id='.$u);
    $row = $oDB->Getrow();    
    $strSubject = $_SESSION[QT]['site_name'].' - Profile updated';
    $strMessage = "Your children (login: %s) has modified his/her profile on the board {$_SESSION[QT]['site_name']}.";
    $strFile = GetLang().'mail_pwd_coppa.php';
    if ( file_exists($strFile) ) include($strFile);
    $strMessage = sprintf($strMessage,$oUser->username,$strNewpwd);
    QTmail($row['parentmail'],QTconv($strSubject,'-4'),QTconv($strMessage,'-4'),QTE_HTML_CHAR);
  }}

  // exit
  if ( $_SESSION[QT]['register_mode']!='direct' ) $strEndmessage='';
  $oVIP->EndMessage(NULL,$L['S_update'].'<br /><br />'.$strEndmessage,$_SESSION[QT]['skin_dir'],0);
  exit;
  break;

// --------------
case 'renamedoc':
// --------------

  if ( $u<0 ) die('Wrong id in '.$oVIP->selfurl);
  if ( !$oVIP->IsStaff() )
  {
    if ( $u!=$oVIP->id ) die('Wrong id in '.$oVIP->selfurl);
  }

  $oVIP->selfname = $L['Rename'];
  $oVIP->exiturl  = Href('qte_user.php').'?id='.$u.'&amp;tt=d';
  $oVIP->exitname = '&laquo; '.$L['Profile'];

  // ask confirmation
  if ( empty($ok) )
  {
    $oDB->Query('SELECT * FROM '.TABDOC.' WHERE docfile="'.$v.'"');
    $row=$oDB->Getrow();

    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden"></td>
    <td class="hidden">
    <form method="get" action="'.Href().'">
    <p><span class="bold">'.$row['docname'].'</span> ('.QTdatestr($row['docdate']).')<p>
    <input type="text" name="name" id="name" size="40" maxlength="255" value="'.$row['docname'].'"/>
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="u" value="'.$u.'"/>
    <input type="hidden" name="v" value="'.$v.'"/>
    <input type="submit" name="ok" value="'.$L['Ok'].'"/>
    </form></td>
    </tr></table>',
    $_SESSION[QT]['skin_dir'],
    0,
    '500px'
    );
    exit;
  }

  // CHANGE
  
  $str = QTconv(trim(strip_tags($_GET['name'])),'3',QTE_CONVERT_AMP); if ( empty($str) ) $str='untitled';
  $oDB->Query( 'UPDATE '.TABDOC.' SET docname="'.$str.'" WHERE docfile="'.$v.'"');

  // EXIT

  $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  exit;
  break;
  
// --------------
case 'userstatus':
// --------------

  if ( !$oVIP->IsStaff() ) die($L['R_staff']);

  $oVIP->selfname = $L['Change_status'];
  $oVIP->exiturl  = Href('qte_user.php').'?id='.$u;
  $oVIP->exitname = '&laquo; '.$L['Profile'];

  // ask confirmation
  if ( empty($ok) )
  {
    $oUser = new cUser($u);
    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden">'.AsImgBoxUser($oUser,'username').'</td>
    <td class="hidden">
    <form method="get" action="'.Href().'">
    <h2>'.$oUser->fullname.'<br />'.AsImg($_SESSION[QT]['skin_dir'].'/'.$oVIP->statuses[$oUser->status]['icon'],$oUser->status,$oVIP->statuses[$oUser->status]['statusname'],'ico i_status').' ('.$oVIP->statuses[$oUser->status]['statusname'].')</h2>
    <br />'.$L['Change_status'].' <select name="v" size="1">'.QTasTag($oVIP->statuses,$oUser->status).'</select>&nbsp;
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="u" value="'.$u.'"/>
    <input type="submit" name="ok" value="'.$L['Ok'].'"/>
    </form></td>
    </tr></table>',
    'admin',
    0,
    '500px'
    );
    exit;
  }

  // CHANGE STATUS
  
  $oDB->Query('UPDATE '.TABUSER.' SET status="'.$v.'" WHERE id='.$u);

  // EXIT

  $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  exit;
  break;

// --------------
case 'userrole':
// --------------

  if ( !$oVIP->IsStaff() ) die($L['R_staff']);
  if ( $u<2 ) die('Wrong parameters: user 0 and 1 cannot be changed');
  include(Translate('qte_reg.php'));

  $oVIP->selfname = $L['Change_role'];
  $oVIP->exiturl  = Href('qte_user.php').'?id='.$u.'&amp;tt=s';
  $oVIP->exitname = '&laquo; '.$L['Profile'];

  // ask confirmation
  if ( empty($ok) )
  {
    $oUser = new cUser($u);
    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden">'.AsImgBoxUser($oUser,'username').'</td>
    <td class="hidden">
    <form method="get" action="'.Href().'">
    <h2>'.$oUser->fullname.'</h2>
    <p style="text-align:right">'.$L['Change_role'].' <select name="v" size="1">
    <option value="A"'.($oUser->role=='A' ? QSEL : '').($oVIP->role!='A' ? ' disabled="disabled"' : '').'>'.$L['Userrole']['A'].'</option>
    <option value="M"'.($oUser->role=='M' ? QSEL : '').'>'.$L['Userrole']['M'].'</option>
    <option value="U"'.($oUser->role=='U' ? QSEL : '').'>'.$L['Userrole']['U'].'</option>
    </select></p>
    <p style="text-align:right"><input type="hidden" name="a" value="'.$a.'"/><input type="hidden" name="u" value="'.$u.'"/><input type="submit" name="ok" value="'.$L['Ok'].'"/>
    </form>
    </td>
    </tr>
    </table>',
    'admin',
    0,
    '500px'
    );
    exit;
  }

  //update role
  if ( $oVIP->role!='A' && $v=='A' ) die($L['R_admin']);
  $oDB->Query('UPDATE '.TABUSER.' SET role="'.$v.'" WHERE id='.$u);
  if ( $v=='U' ) $oDB->Query('UPDATE '.TABSECTION.' SET modid=1, modname="Administrator" WHERE modid='.$u);

  // exit
  $oVIP->EndMessage(NULL,$L['S_update'],'admin',2);
  exit;
  break;
  
// --------------
case 'deleteuser':
// --------------

  if ( !$oVIP->IsStaff() ) die($L['R_staff']);
  if ( $u<2 ) die('Wrong parameters: user 0 and 1 cannot be deleted');
  include(Translate('qte_reg.php'));

  $oVIP->selfname = $L['User_del'];
  if ( $v=='qte_adm_users' ) $oVIP->exiturl='qte_adm_users.php';

  $oUser = new cUser($u);

  // ask confirmation
  if ( empty($ok) )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden">'.AsImgBoxUser($oUser,'username').'</td>
    <td class="hidden">
    <form method="get" action="'.Href().'">
    <h2>'.$oUser->username.'</h2>'.($oUser->username!=$oUser->fullname ? '<p class="bold"> ('.$oUser->fullname.')</p><br />' : '').'
    <p style="text-align:right">'.$L['User_del'].'
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="v" value="'.$v.'"/>
    <input type="hidden" name="u" value="'.$u.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/></p>
    </form>
    </td>
    </tr>
    </table>',
    'admin',
    0,
    '500px'
    );
    exit;
  }

  // delete user
  $oUser->Delete();

  // Unregister global sys (will be recomputed on next page)
  Unset($_SESSION[QT]['sys_members']);
  Unset($_SESSION[QT]['sys_states']);

  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;
  
// --------------
case 'status_del':
// --------------

  if ( $v=='Z' ) die('Wrong id in '.$oVIP->selfurl);

  $oVIP->selfname = $L['Status_del'];
  $oVIP->exiturl  = 'qte_adm_statuses.php';
  $oVIP->exitname = '&laquo; '.$L['Statuses'];

  // ask confirmation
  if ( empty($ok) || !isset($_GET['to']) )
  {
    // list of status destination
    $strSdest = '';
    foreach( $oVIP->statuses as $strKey=>$arrStatus )
    {
      if ( $strKey!=$v ) $strSdest .= '<option value="'.$strKey.'"/>'.$strKey.' - '.$arrStatus['statusname'].'</option>';
    }

    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table cellspacing="0" class="data_o">
    <tr>
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Status'].'</td>
    <td class="colct"><b>'.$v.'&nbsp;&nbsp;'.AsImg($_SESSION[QT]['skin_dir'].'/'.$oVIP->statuses[$v]['icon'],'-',$oVIP->statuses[$v]['statusname'],'ico i_status').'&nbsp;&nbsp;'.$oVIP->statuses[$v]['statusname'].'</b></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">'.$L['Description'].'</td>
    <td class="colct">'.$oVIP->statuses[$v]['statusdesc'].'</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">'.$L['Move'].'</td>
    <td class="colct">'.$L['H_Status_move'].' <select name="to" size="1" class="small">'.$strSdest.'</select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="v" value="'.$v.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/></td>
    </tr>
    </table>
    </form><br />',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // delete status
  $oVIP->StatusDelete($v,$_GET['to']);

  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'moveallmembers':
// --------------

  if ( $s<0 ) die('Wrong id in '.$oVIP->selfurl);
  
  $oVIP->selfname = $L['Members_moveall'];
  $oVIP->exiturl  = 'qte_adm_sections.php';
  $oVIP->exitname = '&laquo; '.$L['Sections'];
    if ( isset($_GET['exit2']) )
    {
    $oVIP->exiturl  = 'qte_adm_users_move.php?s='.$s;
    $oVIP->exitname = '&laquo; '.$L['User_man'];
    }
  $oSEC = new cSection($s);

  // ask confirmation
  if ( empty($ok) )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table cellspacing="0" class="data_o">
    <tr>
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Section'].'</td>
    <td class="colct">'.$oSEC->name.'</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">'.$L['Containing'].'</td>
    <td class="colct">'.LangS('User',$oSEC->members).'</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">'.$L['Move_to'].'</td>
    <td class="colct"><select name="d" size="1">'.Sectionlist(-1,$s).'</select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="submit" name="ok" value="'.$L['Move'].'"/>
    </td>
    </tr>
    </table>
    </form><br />',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // move items from section $s into destination $d
  cSection::MoveItems($s,$d);
  UpdateSectionStats($s);
  UpdateSectionStats($d);


  // exit
  $oVIP->EndMessage(NULL,$L['S_update'],'admin',2);
  exit;
  break;

// --------------
case 'userchild':
// --------------

  if ( !$oVIP->IsStaff() ) die($L['R_staff']);

  $oVIP->selfname = $L['Coppa_apply'];
  $oVIP->exiturl = Href('qte_user.php').'?id='.$u;
  $oVIP->exitname = '&laquo; '.$L['Profile'];

  // ask confirmation
  if ( empty($ok) )
  {
    $oUser = new cUser($u);
    
    // System admin cannot be coppa child
    if ( $oUser->role=='A' ) $L['Coppa_child'] = array($L['Coppa_child'][0]) ;
    
    // form
    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden">'.AsImgBoxUser($oUser,'username').'</td>
    <td class="hidden">
    <form method="get" action="'.Href().'">
    <h2>'.$oUser->fullname.'</h2>
    <p>Username: '.$oUser->username.'<br/>'.$L['Status'].': '.$oVIP->statuses[$oUser->status]['statusname'].' '.AsImg($_SESSION[QT]['skin_dir'].'/'.$oVIP->statuses[$oUser->status]['icon'],$oUser->status,$oVIP->statuses[$oUser->status]['statusname']).'</p>
    <p style="text-align:right">'.$L['Coppa_status'].' <select name="v" size="1">'.QTasTag($L['Coppa_child'],$v).'</select><input type="hidden" name="a" value="'.$a.'"/><input type="hidden" name="u" value="'.$u.'"/></p>
    <p style="text-align:right">'.($oUser->role=='A' ? '<span class="error">System administrator must be major</span>' : '').'<input type="submit" name="ok" value="'.$L['Ok'].'"/></p>
    </form>
    </td>
    </tr>
    </table>',
    'admin',
    0,
    '550px'
    );
    exit;

  }

  // CHANGE CHILD STATUS
  
  $oDB->Query('UPDATE '.TABUSER.' SET children="'.$v.'" WHERE id='.$u);
  if ( $v!=0 )
  {
    $oDB->Query('SELECT count(*) as countid FROM '.TABCHILD.' WHERE id='.$u);
    $row = $oDB->Getrow();
    if ( $row['countid']==0 ) $oDB->Query( 'INSERT INTO '.TABCHILD.' (id,childdate) VALUES ('.$u.',"'.date('Ymd').'")' );
  }
  else
  {
    $oDB->Query( 'DELETE FROM '.TABCHILD.' WHERE id='.$u);
  }  
  // exit
  $oVIP->EndMessage(NULL,$L['S_update'],'admin',2);
  exit;
  break;

// --------------
case 'dropindex':
// --------------

  if ( !$oVIP->IsStaff() ) die($L['R_staff']);
  if ( $u<0 ) die('Wrong id');

  $oVIP->selfname = $L['Delete'].' index keys';
  $oVIP->exiturl = Href('qte_user.php').'?id='.$u.'&amp;tt=s';
  $oUser = new cUser($u);

  // ask confirmation
  if ( empty($ok) )
  {
    $arrIndex = array();
    $oDB->Query('SELECT ufield,ukey FROM '.TABINDEX.' WHERE userid='.$u);
    while( $row = $oDB->Getrow() )
    {
      $arrIndex[] = strtolower($row['ukey']).' ('.$row['ufield'].')';
    }    
    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden" style="width:160px">'.AsImgBoxUser($oUser,'username').'</td>
    <td class="hidden">
    <form method="get" action="'.Href().'">
    <p style="margin-top:0">'.count($arrIndex).' index keys:</p><p class="small">'.implode('<br />',$arrIndex).'</p>
    <p><input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="u" value="'.$u.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/></p>
    </form>
    </td>
    </tr>
    </table>',
    'admin',
    0,
    '500px'
    );
    exit;
  }

  // drop index
  $oDB->query('DELETE FROM '.TABINDEX.' WHERE userid='.$u);

  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'makeindex':
// --------------

  if ( !$oVIP->IsStaff() ) die($L['R_staff']);
  if ( $u<0 ) die('Wrong id');
  
  $oVIP->selfname = 'New index keys';
  $oVIP->exiturl = Href('qte_user.php').'?id='.$u.'&amp;tt=s';
  $oUser = new cUser($u);

  // new keywords
  $arrIndex = array_merge(GetFields('index_p'),GetFields('index_t'));
  $arrIndex = $oUser->GetKeywords($arrIndex);

  // ask confirmation
  if ( empty($ok) )
  {
    
    $str = '';
    $i = 0;
    foreach ($arrIndex as $strKey => $strValue)
    {
      if ( !empty($strValue) ) 
      {
      $str .= '('.$strKey.') '.strtolower(implode(', ',$strValue)).'<br />';
      $i = $i + count($strValue);
      }
    }
    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden" style="width:160px">'.AsImgBoxUser($oUser,'username').'</td>
    <td class="hidden">
    <form method="get" action="'.Href().'">
    <p style="margin-top:0">'.$i.' index keys:</p><p class="small">'.$str.'</p>
    <p><input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="u" value="'.$u.'"/>
    <input type="submit" name="ok" value="'.$L['Save'].'"/></p>
    </form>
    </td>
    </tr>
    </table>',
    'admin',
    0,
    '500px'
    );
    exit;
  }

  // save index
  $oUser->SaveKeywords($arrIndex);

  // exit
  $oVIP->EndMessage(NULL,$L['S_update'],'admin',2);
  exit;
  break;
  
// --------------
default:
// --------------

  echo 'Unknown action';
  break;

// --------------

}

$oVIP->EndMessage('!',"Command [$a] failled...",$_SESSION[QT]['skin_dir'],2);