<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    QuickTeam team
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
$oVIP->selfurl = 'qte_index.php';

// --------
// SECURITY
// --------

if ( $_SESSION[QT]['board_offline']=='1' ) HtmlPage(99);
if ( $_SESSION[QT]['visitor_right']<1 && $oVIP->role=='V' ) HtmlPage(11);

// --------
// INITIALIZE
// --------

if ( isset($_SESSION[QT]['section']) ) unset($_SESSION[QT]['section']); // previous section
$arrSections = GetSections($oVIP->role,-2); // Get all sections at once (grouped by domain)

// --------
// HTML START
// --------

$oHtml->scripts = array();
include('qte_p_header.php');

// --------
// DOMAIN / SECTIONS
// --------

$intDom = 0;
$intSec = 0;
foreach($oVIP->domains as $intDomid=>$strDomtitle)
{
  if ( isset($arrSections[$intDomid]) ) {
  if ( count($arrSections[$intDomid])>0 ) {

    $intDom++;
    if ( $intDom>1 ) echo '<div class="dom_separator"></div>',PHP_EOL;
    echo '<!-- domain ',$intDomid,': ',$strDomtitle,' -->',PHP_EOL;
    echo '<table class="data_s" cellspacing="0">',PHP_EOL;
    echo '<colgroup span="4"><col style="width:50px"></col><col></col><col style="width:200px"></col><col style="width:60px"></col></colgroup>',PHP_EOL;
    echo '<thead>',PHP_EOL;
    echo '<tr class="data_s">';
    echo '<td class="colhd colhdico colhdfirst">&nbsp;</td><td class="colhd">',$strDomtitle,'</td><td class="colhd">&nbsp;</td><td class="colhd center colhdlast">',$L['Users'],'</td>',PHP_EOL;
    echo '</tr>',PHP_EOL;
    echo '</thead>',PHP_EOL;
    echo '<tfoot>',PHP_EOL;
    echo '<tr class="data_s">',PHP_EOL;
    echo '<td class="colft colftfirst"></td><td class="colft"></td><td class="colft"></td><td class="colft colftlast"></td>',PHP_EOL;
    echo '</tr>',PHP_EOL;
    echo '</tfoot>',PHP_EOL;
    echo '<tbody>',PHP_EOL;

    // SHOW SECTIONS

    $strAlt='1';

    foreach($arrSections[$intDomid] as $intSection=>$strSection)
    {
      $intSec++;
      $oSEC = new cSection($intSection);
      echo '<tr class="data_s r',$strAlt,'">';
      echo '<td class="colct colico colfirst">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_'.$oSEC->type.'_'.$oSEC->status.'.gif','[+]',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'ico i_sec','','qte_members.php?s='.$oSEC->id),'</td>';
      echo '<td class="colct"><a class="section" href="',Href('qte_members.php'),'?s=',$oSEC->id,'">',$oSEC->name,'</a><br /><span class="sectiondesc">',$oSEC->descr,'</span></td>';
      echo '<td class="colct center">',(!empty($oSEC->d_logo) ? AsImg('document/section/'.$oSEC->d_logo,'logo',$oSEC->name,'section','','qte_members.php?s='.$oSEC->id) : '&nbsp;'),'</td>';
      echo '<td class="colct center collast">',$oSEC->members,'</td>';
      echo '</tr>',PHP_EOL;
      if ( $strAlt=='1' ) { $strAlt='2'; } else { $strAlt='1'; }
    }

    echo '</tbody>',PHP_EOL;
    echo '</table>',PHP_EOL;

  }}
}

// No public section

if ( $intSec==0 ) echo '<p>',( $oVIP->role=='V' ? $L['E_no_public_section'] : $L['E_no_visible_section'] ),'</p>';

// --------
// HTML END
// --------

if ( isset($oSEC) ) unset($oSEC);
include('qte_p_footer.php');