<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');

// --------
// INITIALISE
// --------

include(GetLang().'qte_reg.php');

$oVIP->selfurl = 'qte_login.php';
$oVIP->selfname = $L['Login'];

$strName = '';
if ( isset($_GET['dfltname']) )
{
  $strName=$_GET['dfltname'];  if ( get_magic_quotes_gpc() ) $strName = stripslashes($strName);
  $strName=QTconv(urldecode($strName),'U');
}

// --------
// SUBMITTED for login
// --------

if ( isset($_POST['ok']) )
{

  // CHECK VALUE

  $strName = trim($_POST['title']); if ( get_magic_quotes_gpc() ) $strName = stripslashes($strName);
  $strName = QTconv($strName,'U');
  if ( !QTislogin($strName) ) $error = ObjTrans('field','username').S.$L['E_invalid'];

  $strPwd = trim($_POST['pwd']); if ( get_magic_quotes_gpc() ) $strPwd = stripslashes($strPwd);
  $strPwd = QTconv($strPwd,'U');
  if ( !QTispassword($strPwd) ) $error = $L['E_pwd_char'];

  // LOGGING IN
  
  if ( empty($error) )
  {

    $arrLog = $oVIP->Login($strName,$strPwd,isset($_POST['remember']));
    
    if ( isset($arrLog['firstname']) && isset($arrLog['lastname']) ) $strName=$arrLog['firstname'].' '.$arrLog['lastname'];

    if ( $oVIP->auth ) 
    {

      // check registered if children (and coppa active)
      if ( $_SESSION[QT]['register_coppa']=='1' ) {
      if ( isset($arrLog['coppa']) ) {
      if ( $arrLog['coppa']==2 ) {
        $_SESSION[QT.'_usr_auth'] = 'no';
        if ( isset($_COOKIE[QT.'_cookname']) ) setcookie(QT.'_cookname', '', time()+60*60*24*100, '/');
        if ( isset($_COOKIE[QT.'_cookpass']) ) setcookie(QT.'_cookpass', '', time()+60*60*24*100, '/');
        if ( isset($_COOKIE[QT.'_cooklang']) ) setcookie(QT.'_cooklang', '', time()+60*60*24*100, '/');
        $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
        $oVIP->EndMessage(NULL,'<h2>'.$L['Welcome'].'<br />'.$strName.'</h2>'.$L['E_access'].'<br />'.$L['E_coppa_confirm'],$_SESSION[QT]['skin_dir'],0);
      }}}

      // upgrade profile

      $oDB->Query('SELECT secret_a FROM '.TABUSER.' WHERE id='.$oVIP->id);
      $row = $oDB->Getrow();
      if ( empty($row['secret_a']) ) 
      {
      $oVIP->exiturl = 'qte_user_question.php?id='.$oVIP->id;
      $oVIP->exitname = $L['Secret_question'];
      $oVIP->EndMessage(NULL,'<h2>'.$L['Welcome'].'<br />'.$strName.'</h2><p>'.$L['Update_secret_question'].'</p>',$_SESSION[QT]['skin_dir'],0,'400px','login_header','login');
      }
      
      // end message
      $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
      $oVIP->EndMessage(NULL,'<h2>'.$L['Welcome'].'<br />'.$strName.'</h2><br /><br />',$_SESSION[QT]['skin_dir'],2,'350px','login_header','login');
    }
    else
    {
      $error = $L['E_access'];
    }
  }
  
}

// --------
// SUBMITTED for logout
// --------

if ( isset($_GET['a']) ) {
if ( $_GET['a']=='out' ) {

  // LOGGING OUT

  $oVIP->Logout();
    
  // REBOOT
  
  GetParam(true);
  
  // check major parameters
  if ( !isset($_SESSION[QT]['skin_dir']) ) $_SESSION[QT]['skin_dir']='skin/default';
  if ( !isset($_SESSION[QT]['language']) ) $_SESSION[QT]['language']='english';
  if ( empty($_SESSION[QT]['skin_dir']) ) $_SESSION[QT]['skin_dir']='skin/default';
  if ( empty($_SESSION[QT]['language']) ) $_SESSION[QT]['language']='english';
  if ( substr($_SESSION[QT]['skin_dir'],0,5)!='skin/' ) $_SESSION[QT]['skin_dir'] = 'skin/'.$_SESSION[QT]['skin_dir'];

  // End message
  $oVIP->selfurl = 'qte_login.php?a=out';
  $oVIP->selfname = $L['Logout'];  
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,'<br />'.$L['Goodbye'].'<br /><br />', $_SESSION[QT]['skin_dir'],2,'300px','login_header','login');

}}

// --------
// HTML START
// --------

include('qte_p_header.php');

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': ',ObjTrans('field','username'),'")); return false; }
  if (theForm.pwd.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': ',$L['Password'],'")); return false; }
  return null;
}
-->
</script>
';

$oHtml->Msgbox($oVIP->selfname,array(),array('id'=>'login_header'),array('id'=>'login'));

if ( !empty($error) ) echo '<span class="error">',$error,'</span>&nbsp;';
echo '<form method="post" action="',Href(),'" onsubmit="return ValidateForm(this);">
<p style="text-align:right"><label for="title">',ObjTrans('field','username'),'</label>&nbsp;<input type="text" id="title" name="title" size="20" maxlength="24" value="',$strName,'" />&nbsp;</p>
<p style="text-align:right"><label for="pwd">',$L['Password'],'</label>&nbsp;<input type="password" id="pwd" name="pwd" size="20" maxlength="24" />&nbsp;</p>
<p style="text-align:right"><input type="checkbox" id="remember" name="remember" />&nbsp;<label for="remember">',$L['Remember'],'</label>&nbsp;&nbsp;
<input type="submit" id="ok" name="ok" value="',$L['Ok'],'" />&nbsp;</p>
<p style="text-align:right"><a class="small" href="',Href('qte_register.php'),'">',$L['Register'],'</a> &middot; <a class="small" href="',Href('qte_reset_pwd.php'),'?a=id">',$L['Forgotten_pwd'],'</a>&nbsp;</p>
</form>
';

$oHtml->Msgbox();

// --------
// HTML END
// --------

$strFooterAddScript = '
<script type="text/javascript">
<!--
document.getElementById("title").focus();
if ( document.getElementById("title").value.length>1 ) { document.getElementById("pwd").focus(); }
-->
</script>
';

include('qte_p_footer.php');