<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
if ( !$oVIP->CanView('V2') ) HtmlPage(11);

$s = -1; QThttpvar('s','int'); if ( $s<0 )  die('Missing team id...');

// ---------
// SUBMITTED
// ---------

if ( isset($_POST['Maction']) )
{
  if ( $_POST['Maction']=='add' ) $oHtml->Redirect('qte_adm_users_move.php?s='.$s,$L['User_man']);
  if ( $_POST['Maction']=='new' ) $oHtml->Redirect('qte_adm_users.php?s='.$s,$L['User_add']);
  if ( $_POST['Maction']=='email' ) $oHtml->Redirect('qte_email.php?s='.$s,$L['User_man']);
  if ( $_POST['Maction']=='show_Z' ) $_SESSION[QT]['show_Z']='1';
  if ( $_POST['Maction']=='hide_Z' ) $_SESSION[QT]['show_Z']='0';
  if ( isset($_POST['infofield']) ) $_SESSION[QT]['infofield']=$_POST['infofield']; // can be ""
}

// ---------
// INITIALISE
// ---------

$strGroup = 'all';
$strOrder = 'lastname';
$strDirec = 'ASC';
$intLimit = 0;
$intPage  = 1;

// security check 1
if ( isset($_GET['group']) ) $strGroup = strip_tags($_GET['group']);
if ( isset($_GET['order']) ) $strOrder = strip_tags($_GET['order']);
if ( isset($_GET['dir']) ) $strDirec = strip_tags($_GET['dir']);
if ( isset($_GET['page']) ) $intPage = intval(strip_tags($_GET['page']));
if ( isset($_GET['view']) ) $_SESSION[QT]['viewmode'] = strip_tags($_GET['view']);

// security check 2 (no long argument)
if ( strlen($strGroup)>4 ) die('Invalid argument #group');
if ( strlen($strOrder)>12 ) die('Invalid argument #order');
if ( strlen($strDirec)>4 ) die('Invalid argument #dir');

$intLimit = ($intPage-1)*$_SESSION[QT]['items_per_page'];

$_SESSION[QT]['section']= $s; // previous section

include('bin/qte_fn_sql.php');

$oSEC = new cSection($s);

if ( $oSEC->type==1 && !$oVIP->IsStaff() )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',ObjTrans('index','i',$_SESSION[QT]['index_name']));
  $oVIP->EndMessage(NULL,$L['R_staff'],$_SESSION[QT]['skin_dir'],0);
}
if ( $oSEC->type==2 && $oVIP->role=='V' )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',ObjTrans('index','i',$_SESSION[QT]['index_name']));
  $oVIP->EndMessage(NULL,$L['R_user'],$_SESSION[QT]['skin_dir'],0);
}

$oVIP->selfurl = 'qte_members.php';
$oVIP->selfname = $L['Section'].': '.$oSEC->name;

$strShowZ = ''; if ( !$_SESSION[QT]['show_Z'] ) $strShowZ = ' AND u.status<>"Z"';

// COUNT Members

$strWhereGroup = '';
switch ($strGroup)
{
  case 'all': $strWhereGroup .= ' AND u.id>0'; Break;
  case '0':   $strWhereGroup .= ' AND '.FirstCharCase('u.lastname','a-z'); Break;
  default:    $strWhereGroup .= ' AND '.FirstCharCase('u.lastname','u').'="'.$strGroup.'"'; Break;
}
$oDB->Query('SELECT count(*) as countid FROM '.TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid=u.id WHERE l.sid='.$oSEC->id.$strShowZ.$strWhereGroup);
$row = $oDB->Getrow();
$intCount = $row['countid'];

// --------
// Pager
// --------

$strPager = MakePager(Href().'?'.GetURI('page'),$intCount,$_SESSION[QT]['items_per_page'],$intPage); 
if ( $strPager!='' ) { $strPager = $L['Page'].$strPager; } else { $strPager=S; }
if ( $intCount<$oSEC->members ) $strPager = '<span class="small">'.$intCount.' '.$L['Selected_from'].' '.$oSEC->members.' '.strtolower($L['Users']).'</span>'.($strPager==S ? '' : ' | '.$strPager);

// MAP MODULE

if ( UseModule('map') ) { $strCheck=$s; include('qtem_map_ini.php'); } else { $bMap=false; }

// --------
// HTML START
// --------

include('qte_p_header.php');

  // Staff Actions
  if ( $oVIP->IsStaff() )
  {
    // get the usable field list
    $arr = GetFLDnames(GetFLDs('status_i;fullname'));
    $arr['-'] = '--------';
    $arr = $arr + GetFLDnames(GetFLDs('title;firstname;midname;lastname;alias;picture;address;phones;emails;www;birthdate;age;nationality;sexe'));
    $arr['--'] = '--------';
    $arr = $arr + GetFLDnames(GetFLDs('teamid1;teamid2;teamrole1;teamrole2;teamdate1;teamdate2;teamvalue1;teamvalue2;teamflag1;teamflag2;descr'));
    $arr['---'] = '--------';
    $arr = $arr + GetFLDnames(GetFLDs('id;username;role;status;children;firstdate'));
    // get current infofield (if exist)
    $strCurrentInfofield=''; if ( isset($_SESSION[QT]['infofield']) ) $strCurrentInfofield=$_SESSION[QT]['infofield'];

    // build listing of disabled used fields
    $arrUsed = GetFLDs($oSEC->forder,false,true); // this get the ACTIVE fields (as fieldkey) out of the section fields
    $arrUsed[] = '-';
    $arrUsed[] = '--';
    $arrUsed[] = '---';

    echo '
    <form method="post" action="',Href(),'?s=',$s,'" id="modaction">
    <div class="modboard">
    <span class="modboard">',$L['Userrole'][$oVIP->role],' 
    <select name="Maction" class="small" onchange="',"document.getElementById('modaction').submit();",'">
    <option value="">&nbsp;</option>
    <optgroup label="Action">
    ';
    if ( $oSEC->status==1 && $oVIP->role=='M' ) 
    {
    echo '<option value="add" disabled="disabled">',$L['User_man'],'...</option>',PHP_EOL;
    }
    else
    {
    echo '<option value="add">',$L['User_man'],'...</option>',PHP_EOL;
    }
    if ( $oVIP->role=='A' ) echo '<option value="new">',$L['User_add'],'...</option>';
    echo '
    <option value="email">',$L['Emails'],'...</option>
    </optgroup>
    <optgroup label="Option">
    <option value="show_Z"',($_SESSION[QT]['show_Z'] ? ' class="bold"' : ''),'>',$L['Show'],': ',$oVIP->statuses['Z']['statusname'],'</option>
    <option value="hide_Z"',(!$_SESSION[QT]['show_Z'] ? ' class="bold"' : ''),'>',$L['Hide'],': ',$oVIP->statuses['Z']['statusname'],'</option>
    </optgroup>
    </select> ',$L['Last_column'],S;
    echo '<select id="infofield" name="infofield" class="small" onchange="',"document.getElementById('modaction').submit();",'">';
    echo '<option value="">',S,'</option>';
    echo QTasTag($arr,$strCurrentInfofield,array(),'option',$arrUsed);
    if ( $bMap ) echo '<option value="coord">',$L['Coord'],'</option>';
    echo '</select><input type="submit" name="Mok" value="',$L['Ok'],'" class="small" id="action_ok"/>
    <input type="hidden" name="s" value="',$oSEC->id,'"/>
    <script type="text/javascript">document.getElementById("action_ok").style.display="none";document.getElementById("action_ok").value="";</script>
    </span>
    </div>
    </form>',PHP_EOL;
  }
  // End staff Actions

// Display description

if ( $_SESSION[QT]['section_descr']=='1' )
{
  $oSEC->descr .= (empty($oSEC->descr) ? '' : '<br />').'<span class="small">('.LangS('User',$oSEC->members).')</span>';
  $oSEC->ShowInfo('sectioninfo_left','sectioninfo','sectiondesc');
}

// Display letters bar

if ( $intCount>$_SESSION[QT]['items_per_page'] || isset($_GET['group']) ) echo '<table class="lettres" cellspacing="0"><tr class="lettres">',HtmlLettres($strGroup,$s,$L['All']),'</tr></table>',PHP_EOL;

// Display no member

if ( $intCount==0 )
{
  TableEmpty($L['E_no_member'].'...');
  if ( $oSEC->members>0 && $oVIP->IsStaff() && !empty($strShowZ) )
  {
    $oDB->Query( 'SELECT count(*) as countid FROM '.TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid=u.id WHERE l.sid='.$oSEC->id.' AND u.status="Z"' );
    $row = $oDB->Getrow();
    $i = intval($row);
    if ( $i>0 ) echo '<p class="disabled">',$L['Hidden'],': ',strtolower(LangS('User',$i).' ('.$L['Status'].' '.$oVIP->statuses['Z']['statusname']),')</p>';
  }
  include('qte_p_footer.php');
  exit;
}

// Display top pager

if ( $strPager )
{
echo '
<table class="hidden" cellspacing="0"><tr class="hidden"><td class="pager_zt">',$strPager,'</td></tr></table>
';}
else
{
echo '<br />',PHP_EOL;
}

// --------
// Prepare fields
// --------

$arrFLD = GetFLDs($oSEC->forder.(!empty($_SESSION[QT]['infofield']) ? ';'.$_SESSION[QT]['infofield'] : ''));

// check current order (if using default)

if ( !array_key_exists($strOrder,$arrFLD) )
{
  $strOrder='fullname'; if ( !array_key_exists($strOrder,$arrFLD) ) $strOrder='username';
}

if ( isset($arrFLD['status']) )
{
$arrStatusStyles=array();
foreach($oVIP->statuses as $id=>$arrStatus) if ( !empty($arrStatus['color']) ) $arrStatusStyles[$id]=$arrStatus['color'];
}

// Fields exception

$i=0;
foreach($arrFLD as $strKey=>$oFLD)
{
  $i++;
  // extraclass
  $str_th = '';
  $str_td = '';
  if ( $i==1 ) { $str_th=' colhdfirst'; $str_td=' colfirst'; }
  if ( $i==count($arrFLD) ) { $str_th=' colhdlast'; $str_td=' collast'; }

  // define the fields 
  switch ($strKey)
  {
  case 'status_i': $oFLD->sort='ASC'; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; $oFLD->name=' &bull; '; break;
  case 'status':   $oFLD->sort='ASC'; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; $oFLD->style_dynamic=array('background-color:%s','status',$arrStatusStyles); break;
  case 'address':  $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'descr':    $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'picture':  $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'phones':   $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'birthdate':
  case 'age':      $oFLD->sort='ASC';$oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'emails':   $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'emails_i': $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'coord':    $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; $oFLD->name=$L['Coord']; break;
  default:         $oFLD->sort='ASC'; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  }
  $arrFLD[$strKey]=$oFLD;
}

$bLink = true;
if ( isset($qte_web_link) ) {
if ( !$qte_web_link ) {
  $bLink = false;
}}

// --------
// Display members
// --------

echo '<table class="data_t" cellspacing="0">
<thead>
<tr class="data_t">'; TableHeader($arrFLD,$intCount,$oVIP->selfurl.'?'.GetURI('order,dir'),$strOrder,$strDirec); echo '</tr>
</thead>
<tfoot>
<tr class="data_t"><td class="colft colftfirst"></td>'; for($i=0;$i<(count($arrFLD)-2);$i++) echo '<td class="colft"></td>'; echo '<td class="colft colftlast"></td></tr>
</tfoot>
<tbody>
';

$strState = 'u.* FROM '.TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid=u.id WHERE l.sid='.$oSEC->id.$strShowZ.$strWhereGroup;
if ( substr($strOrder,0,2)!='u.' ) $strOrder = 'u.'.$strOrder;
$strOrder .= ' '.$strDirec;
$strOrder = str_replace('u.fullname','u.lastname',$strOrder);
$strOrder = str_replace('u.status_i','u.status',$strOrder);
$strOrder = str_replace('u.age','u.birthdate',$strOrder);
  // second order
  if ( !strstr($strOrder,'lastname') ) $strOrder .= ',u.lastname'; 
$oDB->Query( LimitSQL($strState,$strOrder,$intLimit,$_SESSION[QT]['items_per_page']) );
$strAlt='r1';
while($row=$oDB->Getrow())
{
  TableRowShow($arrFLD,TableUserFormat($arrFLD,$row,$s,$bMap,false),'data_t '.$strAlt,$row);
  if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
}

echo '
</tbody>
</table>
';

// --------
// Display bottom pager
// --------

// define csv options according to $intCount (max 10000)

$strCsv ='';
if ( $oVIP->role!='V' )
{
  if ( $intCount<=$_SESSION[QT]['items_per_page'] )
  {
  $strCsv = '<a href="'.Href('qte_members_csv.php').'?'.GetURI('page').'&amp;size=all&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].'</a>';
  }
  else
  {
  $strCsv = '<a href="'.Href('qte_members_csv.php').'?'.GetURI('page').'&amp;size=p'.$intPage.'&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">('.strtolower($L['Page']).')</span></a>';
  if ( $intCount<=1000 )                   $strCsv .= ' &middot; <a href="'.Href('qte_members_csv.php').'?'.GetURI('page').'&amp;size=all&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">('.strtolower($L['All']).')</span></a>';
  if ( $intCount>1000 && $intCount<=2000 ) $strCsv .= ' &middot; <a href="'.Href('qte_members_csv.php').'?'.GetURI('page').'&amp;size=m1&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(1-1000)</span></a> &middot; <a href="'.Href('qte_members_csv.php').'?'.GetURI('page').'&amp;size=m2&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(1000-'.$intCount.')</span></a>';
  if ( $intCount>2000 && $intCount<=5000 ) $strCsv .= ' &middot; <a href="'.Href('qte_members_csv.php').'?'.GetURI('page').'&amp;size=m5&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(1-5000)</span></a>';
  if ( $intCount>5000 )                    $strCsv .= ' &middot; <a href="'.Href('qte_members_csv.php').'?'.GetURI('page').'&amp;m=5&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(1-5000)</span></a> &middot; <a href="'.Href('qte_members_csv.php').'?'.GetURI('page').'&amp;m=10&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(5000-10000)</span></a>';
  }
}
if ( !empty($strCsv) )
{
  $strPager = $strCsv.( $strPager==S || empty($strPager) ? '' : ' &middot; '.$strPager );
}

// calendar view (if allowed)

$strCal ='';
if ( $oVIP->CanViewCalendar() )
{
  $strCal = '<a href="'.Href('qte_calendar.php').'?s='.$s.'" class="tablecommand csv">'.$L['Birthdays_calendar'].'</a>';
}
if ( !empty($strCal) )
{
  $strPager = $strCal.( $strPager==S || empty($strPager) ? '' : ' &middot; '.$strPager );
}

// show table command

if ( !empty($strPager) && $strPager!=S )
{
echo '
<table class="hidden" cellspacing="0"><tr class="hidden"><td class="pager_zb">',$strPager,'</td></tr></table>
';
}

// --------
// Map module
// --------

if ( $bMap )
{
  echo '<!-- Map module -->',PHP_EOL;
  if ( count($arrExtData)>0 )
  {
    $strMapHelp = sprintf($L['map']['items'],strtolower(LangS('User',count($arrExtData))),strtolower(LangS('User',$oSEC->members)) );
    echo '<table class="hidden" style="margin-top:5px;">',PHP_EOL;
    echo '<tr class="hidden">',PHP_EOL;
    echo '<td class="gmap">',PHP_EOL;
    if ( !$_SESSION[QT]['m_map_hidelist'] )
    {
    echo QTgmapZoomControl($arrExtData);
    echo '<div id="map_canvas" style="width:100%; height:',($_SESSION[QT]['viewmode']=='C' ? '350' : '400'),'px;"></div>',PHP_EOL;
    }
    if ( !empty($strMapHelp) ) echo '<p class="gmap" style="margin:4px 0 0 0">'.$strMapHelp.'</span>';
    echo '</td>',PHP_EOL;
    echo '</tr>',PHP_EOL;
    echo '</table>',PHP_EOL;

    // Show/Hide

    if ( $_SESSION[QT]['m_map_hidelist'] )
    {
    echo '<p style="margin:2px"><a href="',Href(),'?',GetURI('hidemap'),'&amp;hidemap=0">',$L['map']['Show_map'],'</a></p>';
    }
    else
    {
    echo '<p style="margin:2px"><a href="',Href(),'?',GetURI('hidemap'),'&amp;hidemap=1">',$L['map']['Hide_map'],'</a></p>';
    }
  }
  else
  {
    echo '<p class="gmap">'.$L['map']['E_noposition'].'</p>',PHP_EOL;
  }
  echo '<!-- Map module end -->',PHP_EOL;
}

// --------
// HTML END
// --------

// MAP MODULE

if ( $bMap )
{
  if ( count($arrExtData)>0 )
  {
  if ( count($arrExtData)>1 && isset($_SESSION[QT]['m_map'][$s]['zoom']) ) $bZoomAll=($_SESSION[QT]['m_map'][$s]['zoom']=='1' ? true : false);
  include('qtem_map_load.php');
  }
  else
  {
  echo '<script type="text/javascript">function GUnload() { return true; }</script>';
  }
}

include('qte_p_footer.php');