<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Adressbook
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
$oVIP->output='csv';
if ( !$oVIP->CanView('V2') ) die(Error(11));

$s = -1; QThttpvar('s','int',true,true,false); if ( $s<0 )  die('Missing team id...');

// ---------
// INITIALISE
// ---------

// Check arguments

$size = strip_tags($_GET['size']);
$intCount = intval($_GET['n']);

if ( empty($size) || $intCount <= $_SESSION[QT]['items_per_page'] ) $size='all';
if ( strlen($size)>6 || strlen($size)<2 ) die('Invalid argument');
if ( substr($size,0,1)!='p' && substr($size,0,1)!='m' && $size!='all') die('Invalid argument');
if ( substr($size,0,1)=='p' )
{
  $i = intval(substr($size,1));
  if ( empty($i) ) die('Invalid argument');
  if ( ($i-1) > $intCount/$_SESSION[QT]['items_per_page'] ) die('Invalid argument');
}
if ( substr($size,0,1)=='m' )
{
  if ( $size!='m1' && $size!='m2' && $size!='m5' && $size!='m10' ) die('Invalid argument');
}
if ( $intCount>1000 && $size=='all' ) die('Invalid argument');
if ( $intCount<=1000 && substr($size,0,1)=='m' ) die('Invalid argument');
if ( $intCount>1000 && substr($size,0,1)=='p' ) die('Invalid argument');

// apply page argument

if ( substr($size,0,1)=='p' ) $_GET['page'] = substr($size,1);

// Initialise

$strCSV = '';

include('bin/qte_fn_sql.php');

$oSEC = new cSection($s);

if ( $oSEC->type==1 && !$oVIP->IsStaff() )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,$L['R_staff'],$_SESSION[QT]['skin_dir'],0);
}
if ( $oSEC->type==2 && $oVIP->role=='V' )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,$L['R_user'],$_SESSION[QT]['skin_dir'],0);
}

$oVIP->selfurl = 'qte_members.php';
$oVIP->selfname = $L['Section'].': '.$oSEC->name;

$strCommand = '';
$numid = '';

$strGroup = 'all';
$strOrder = 'lastname';
$strDirec = 'ASC';
$intPage = 1;
$intLimit = 0;
$intLen = $_SESSION[QT]['items_per_page'];

// security check 1
if ( isset($_GET['group']) ) $strGroup = strip_tags($_GET['group']); if ( strlen($strGroup)>4 ) die('Invalid argument #group');
if ( isset($_GET['page']) ) { $intLimit = (intval($_GET['page'])-1)*$intLen; $intPage = intval($_GET['page']); }
if ( isset($_GET['order']) ) $strOrder = strip_tags($_GET['order']);
if ( isset($_GET['dir']) ) $strDirec = strip_tags($_GET['dir']);

// apply argument

if ( $size=='all') { $intLimit=0; $intLen=$intCount; }
if ( $size=='m1' ) { $intLimit=0; $intLen=999; }
if ( $size=='m2' ) { $intLimit=1000; $intLen=1000; }
if ( $size=='m5' ) { $intLimit=0; $intLen=4999; }
if ( $size=='m10') { $intLimit=5000; $intLen=5000; }

// refine query

$strShowZ = ''; if ( !$_SESSION[QT]['show_Z'] ) $strShowZ = ' AND u.status<>"Z"';
$strWhereGroup = '';
switch ($strGroup)
{
  case 'all': $strWhereGroup .= ' AND u.id>0'; Break;
  case '0':   $strWhereGroup .= ' AND '.FirstCharCase('u.lastname','a-z'); Break;
  default:    $strWhereGroup .= ' AND '.FirstCharCase('u.lastname','u').'="'.$strGroup.'"'; Break;
}

// MAP MODULE

if ( UseModule('map') ) { $strCheck=$s; include('qtem_map_ini.php'); } else { $bMap=false; }

// --------
// HTML START
// --------

// Prepare fields

$arrFLD = GetFLDs($oSEC->forder.(!empty($_SESSION[QT]['infofield']) ? ';'.$_SESSION[QT]['infofield'] : ''));
$arrFLD['uid']= new cFLD('uid','UID');

// check current order (if using default)

if ( !array_key_exists($strOrder,$arrFLD) )
{
  $strOrder='fullname'; if ( !array_key_exists($strOrder,$arrFLD) ) $strOrder='username';
}

// ========
foreach($arrFLD as $strKey=>$oFLD)
{
$strCSV .= ToCsv($oFLD->name);
}
$strCSV .= "\r\n";
// ========

// ========
$strState = 'u.* FROM '.TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid=u.id WHERE l.sid='.$oSEC->id.$strShowZ.$strWhereGroup;
if ( substr($strOrder,0,2)!='u.' ) $strOrder = 'u.'.$strOrder;
$strOrder .= ' '.$strDirec;
$strOrder = str_replace('u.fullname','u.lastname',$strOrder);
$strOrder = str_replace('u.status_i','u.status',$strOrder);
  // second order
  if ( strstr($strOrder,'lastname') ) $strOrder .= ',u.lastname'; 
$oDB->Query( LimitSQL($strState,$strOrder,$intLimit,$_SESSION[QT]['items_per_page']) );
// ========
$intWhile=0;
while($row=$oDB->Getrow())
{
  $str = implode('',TableUserFormat($arrFLD,$row,null,false,true,$qte_root));
  if ( substr($str,-1,1)==';' ) $str = substr($str,0,-1);
  $strCSV .= $str."\r\n";

  $intWhile++; 
  //odbcbreak
  if ( $intWhile>=$intCount ) break;  
}
// ========

// ----------
// OUPUT
// ----------

if ( isset($_GET['debug']) )
{
  echo $strCSV;
  exit;
}

if ( !headers_sent() )
{
  header('Content-Type: text/csv; charset='.QTE_HTML_CHAR);
  header('Content-Disposition: attachment; filename="qte_'.date('YmdHi').'.csv"');
}

echo $strCSV;