<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
if ( !$oVIP->CanView('V3') ) die(Error(11));
include('bin/qte_fn_sql.php');

// ---------
// INITIALISE
// ---------

$strOrder = 'username';
$strDirec = 'ASC';
$intPage  = 1;
$intLimit = 0;
$intCount = 0;
if ( isset($_GET['view'])) $_SESSION[QT]['viewmode'] = strip_tags($_GET['view']);
$s = 'S';

$oVIP->selfurl = 'qte_result.php';
$oVIP->selfname = $L['Search_result'];
$oVIP->exiturl = 'qte_search.php';
$oVIP->exitname = $L['Search'];

// MAP MODULE

if ( UseModule('map') ) { $strCheck='S'; include('qtem_map_ini.php'); }  else { $bMap=false; }

// --------
// SUBMITTED
// --------

if ( isset($_GET['title']) ) {
if ( strlen($_GET['title'])<2 ) {
  // exit
  $oVIP->exiturl = 'qte_search.php?';
  if ( isset($_GET['title']) ) $oVIP->exiturl .= '?title='.$_GET['title'];
  if ( isset($_GET['role']) ) $oVIP->exiturl .= '&amp;role='.$_GET['role'];
  if ( isset($_GET['status']) ) $oVIP->exiturl .= '&amp;status='.$_GET['status'];
  if ( isset($_GET['s']) ) $oVIP->exiturl .= '&amp;s='.$_GET['s'];
  $oVIP->EndMessage(NULL,$L['E_min_2_char'],$_SESSION[QT]['skin_dir'],2);
}}

$strInfo = '';

if ( isset($_GET['role']) )
{  
  $strSelect = '"role" as ufield,"'.$L['Userrole'][$_GET['role']].'" as ukey,u.id,u.username,u.title,u.firstname,u.midname,u.lastname,u.picture,u.status,u.phones,u.emails,u.privacy,u.y,u.x';
  $strFrom = TABUSER.' u';
  $strWhere = 'u.id>0 AND u.role="'.$_GET['role'].'"';
  $strInfo .= $L['Userroles'][$_GET['role']];
  if ( isset($_GET['s']) )
  {  
    if ( $_GET['s']>=0 )
    {  
    $strFrom = TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid = u.id';
    $strWhere .= ' AND l.sid='.$_GET['s'];
    $strInfo .= ' '.$L['In_section'].' "'.$oVIP->sections[$_GET['s']].'"';
    }
  }  
}
if ( isset($_GET['age_criteria']) && isset($_GET['age']) )
{  
  $strFrom = TABUSER.' u';
  $strWhere = 'u.id>0';
  $intDate = date('Ymd');
  $intDate = intval($intDate)-intval($_GET['age'].'0000');
  switch ($_GET['age_criteria'])
  {
  case 'l':
    $strSelect = '"age" as ufield,"< '.$_GET['age'].'" as ukey,u.id,u.username,u.title,u.firstname,u.midname,u.lastname,u.picture,u.status,u.phones,u.emails,u.birthdate,u.privacy,u.y,u.x';
    $strWhere .= ' AND u.birthdate<>"0" AND "'.$intDate.'"<u.birthdate';
    $strInfo .= $L['Age'].'<'.$_GET['age'];
    break;
  case 'u':
    $strSelect = '"age" as ufield,">='.$_GET['age'].'" as ukey,u.id,u.username,u.title,u.firstname,u.midname,u.lastname,u.picture,u.status,u.phones,u.emails,u.birthdate,u.privacy,u.y,u.x';
    $strWhere .= ' AND u.birthdate<>"0" AND "'.$intDate.'">=u.birthdate';
    $strInfo .= $L['Age'].'>='.$_GET['age'];
    break;
  case 'e':
    $strSelect = '"age" as ufield,"='.$_GET['age'].'" as ukey,u.id,u.username,u.title,u.firstname,u.midname,u.lastname,u.picture,u.status,u.phones,u.emails,u.birthdate,u.privacy,u.y,u.x';
    $strInfo .= $L['Age'].'='.$_GET['age'];
    if ( $_GET['age']=="0" )
    {
    $strWhere .= ' AND u.birthdate="0"';
    }
    else
    {
    $strWhere .= ' AND u.birthdate<>"0" AND "'.$intDate.'">=u.birthdate AND "'.($intDate-10000).'"<u.birthdate';
    }
    break;
  }    
  if ( isset($_GET['s']) )
  {  
    if ( $_GET['s']>=0 )
    {  
    $strFrom = TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid = u.id';
    $strWhere .= ' AND l.sid='.$_GET['s'];
    $strInfo .= ' '.$L['In_section'].' "'.$oVIP->sections[$_GET['s']].'"';
    }
  }  
}
if ( isset($_GET['status']) )
{  
  $strSelect = '"status" as ufield,"'.$oVIP->statuses[$_GET['status']]['statusname'].'" as ukey,u.id,u.username,u.title,u.firstname,u.midname,u.lastname,u.picture,u.status,u.phones,u.emails,u.privacy,u.y,u.x';
  $strFrom = TABUSER.' u';
  $strWhere = 'u.id>0  AND u.status="'.$_GET['status'].'"';
  $strInfo .= $L['Status'].' "'.$oVIP->statuses[$_GET['status']]['statusname'].'"';
  if ( isset($_GET['s']) )
  {  
    if ( $_GET['s']>=0 )
    {  
    $strFrom = TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid = u.id';
    $strWhere .= ' AND l.sid='.$_GET['s'];
    $strInfo .= ' '.$L['In_section'].' "'.$oVIP->sections[$_GET['s']].'"';
    }
  }  
}
if ( isset($_GET['title']) )
{
  $strSelect = 'i.ufield,i.ukey,u.id,u.username,u.title,u.firstname,u.midname,u.lastname,u.picture,u.status,u.phones,u.emails,u.privacy,u.y,u.x';
  $strFrom = TABINDEX.' i INNER JOIN '.TABUSER.' u ON i.userid=u.id';
  $str = trim($_GET['title']); if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
  $str = strtoupper($str);
  $strWhere = 'i.userid>0 AND UPPER(i.ukey) LIKE "%'.$str.'%"';
  $strInfo .= $L['Users_with'].' "'.$str.'"';
  if ( isset($_GET['s']) )
  {  
    if ( $_GET['s']>=0 )
    {  
    $strFrom = TABINDEX.' i INNER JOIN '.TABUSER. ' u ON i.userid=u.id INNER JOIN '.TABS2U.' l ON l.userid = u.id';
    $strWhere .= ' AND l.sid='.$_GET['s'];
    $strInfo .= ' '.$L['In_section'].' "'.$oVIP->sections[$_GET['s']].'"';
    }
  }
}

if ( empty($strInfo) ) die('Missing parameters');
if (isset($_GET['page'])) { $intLimit = ($_GET['page']-1)*$_SESSION[QT]['items_per_page']; $intPage=$_GET['page']; } else { $intLimit=0; $intPage=1; }
if (isset($_GET['order'])) $strOrder = $_GET['order'];
if (isset($_GET['dir']))   $strDirec = $_GET['dir'];

// --------
// QUERY PREPARATION
// --------

// Order
$strFullOrder = 'u.'.$strOrder.' '.$strDirec;
if ( $strOrder=='fullname' ) $strFullOrder='u.lastname'.' '.$strDirec;
  // second order
  if ( $strOrder!='firstname' ) $strFullOrder .= ',u.firstname ASC';

// -----
// COUNT
// -----

$oDB->Query('SELECT DISTINCT u.id FROM '.$strFrom.' WHERE '.$strWhere); //count only distinct id
while($row=$oDB->Getrow()) $intCount++;

// second search if no result with keyword
if ( $intCount==0 && isset($_GET['title']) )
{
  $str = trim($_GET['title']); if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
  $str = strtoupper($str);
  $strSelect = '"'.$L['Name'].'" as ufield,"'.$str.'" as ukey,u.id,u.username,u.title,u.firstname,u.midname,u.lastname,u.picture,u.status,u.phones,u.emails,u.privacy,u.y,u.x';
  $strFrom = TABUSER.' u ';
  $strWhere = 'u.id>0 AND (UPPER(u.lastname) LIKE "%'.$str.'%" OR UPPER(u.username) LIKE "%'.$str.'%" OR UPPER(u.firstname) LIKE "%'.$str.'%")';
  $oDB->Query('SELECT DISTINCT u.id FROM '.$strFrom.' WHERE '.$strWhere); //count only distinct id
  while($row=$oDB->Getrow()) $intCount++;
}

// --------
// HTML START
// --------

include('qte_p_header.php');

// --------
// Display info
// --------

echo '<h2>'.$oVIP->selfname.'</h2>',PHP_EOL;
echo '<p>'.$strInfo,' &middot; ',LangS('Result',$intCount),S,'&middot; <a href="',Href('qte_search.php'),'?',GetURI('page,ok,order,dir'),'">',$L['Search'],'</a></p>',PHP_EOL;

// --------
// Display no member
// --------

if ( $intCount==0 )
{
  include('qte_p_footer.php');
  exit;
}

// --------
// Pager
// --------

$strPager = MakePager(Href().'?'.GetURI('page,ok'),$intCount,$_SESSION[QT]['items_per_page'],$intPage);
if ( $strPager ) $strPager = $L['Page'].$strPager;

// --------
// Display top pager
// --------

if ( $strPager )
{
echo '
<table class="hidden" cellspacing="0"><tr class="hidden"><td class="pager_zt">',$strPager,'</td></tr></table>
';
}
else
{
echo '<p></p>';
}

// --------
// Prepare fields
// --------

$arrFLD = GetFLDs('ufield;status_i;fullname;phones;emails_i;picture',false);

// check current order (if using default)

if ( !array_key_exists($strOrder,$arrFLD) )
{
  $strOrder='fullname'; if ( !array_key_exists($strOrder,$arrFLD) ) $strOrder='username';
}

// Fields exception

$i=0;
foreach($arrFLD as $strKey=>$oFLD)
{
  $i++;
  // extraclass
  $str_th = '';
  $str_td = '';
  if ( $i==1 ) { $str_th=' colhdfirst'; $str_td=' colfirst'; }
  if ( $i==count($arrFLD) ) { $str_th=' colhdlast'; $str_td=' collast'; }

  // define the fields
  switch ($strKey)
  {
  case 'ufield':   $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; $oFLD->name=$L['Result']; break;
  case 'status_i': $oFLD->sort='ASC'; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; $oFLD->name=' &bull; '; break;
  case 'address':  $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'descr':    $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'picture':  $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'phones':   $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'age':      $oFLD->sort='DESC';$oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'emails':   $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'emails_i': $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  case 'coord':    $oFLD->sort=false; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; $oFLD->name=$L['Coord']; break;
  default:         $oFLD->sort='ASC'; $oFLD->class_th='colhd col_'.$strKey.$str_th; $oFLD->class_td='colct col_'.$strKey.$str_td; break;
  }
  $arrFLD[$strKey]=$oFLD;
}

$bLink = true;
if ( isset($qte_web_link) ) {
if ( !$qte_web_link ) {
  $bLink = false;
}}

// --------
// Display members
// --------

echo '<table class="data_t" cellspacing="0">
<thead>
<tr class="data_t">'; TableHeader($arrFLD,$intCount,$oVIP->selfurl.'?'.GetURI('order,dir,ok'),$strOrder,$strDirec); echo '</tr>
</thead>
<tfoot>
<tr class="data_t"><td class="colft colftfirst"></td>'; for($i=0;$i<(count($arrFLD)-2);$i++) echo '<td class="colft"></td>'; echo '<td class="colft colftlast"></td></tr>
</tfoot>
<tbody>
';
$oDB->Query( LimitSQL( $strSelect.' FROM '.$strFrom.' WHERE '.$strWhere, $strFullOrder,$intLimit,$_SESSION[QT]['items_per_page']) );
$arrSearch = array();
$arrUid = array();
while($row=$oDB->Getrow())
{
  if ( in_array($row['id'],$arrUid) ) continue; // prevent duplicate id (as from search query)
  $arrUid[]=$row['id'];
  if ( isset($row['ufield']) ) $arrSearch['ufield']=$row['ufield'];
  if ( isset($row['ukey']) ) $arrSearch['ukey']=$row['ukey'];
  TableRowShow($arrFLD,TableUserFormat($arrFLD,$row,$s,$bMap,false,$qte_root,$arrSearch));
}
echo '
</tbody>
</table>
';

// --------
// Display bottom pager
// --------

// define csv options according to $intCount (max 10000)

$strCsv ='';
if ( $oVIP->role!='V' )
{
  if ( $intCount<=$_SESSION[QT]['items_per_page'] )
  {
  $strCsv = '<a href="'.Href('qte_result_csv.php').'?'.GetURI('page,ok').'&amp;size=all&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].'</a>';
  }
  else
  {
  $strCsv = '<a href="'.Href('qte_result_csv.php').'?'.GetURI('page,ok').'&amp;size=p'.$intPage.'&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">('.strtolower($L['Page']).')</span></a>';
  if ( $intCount<=1000 )                   $strCsv .= ' &middot; <a href="'.Href('qte_result_csv.php').'?'.GetURI('page,ok').'&amp;size=all&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">('.strtolower($L['All']).')</span></a>';
  if ( $intCount>1000 && $intCount<=2000 ) $strCsv .= ' &middot; <a href="'.Href('qte_result_csv.php').'?'.GetURI('page,ok').'&amp;size=m1&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(1-1000)</span></a> &middot; <a href="'.Href('qte_result_csv.php').'?'.GetURI('page,ok').'&amp;size=m2&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(1000-'.$intCount.')</span></a>';
  if ( $intCount>2000 && $intCount<=5000 ) $strCsv .= ' &middot; <a href="'.Href('qte_result_csv.php').'?'.GetURI('page,ok').'&amp;size=m5&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(1-5000)</span></a>';
  if ( $intCount>5000 )                    $strCsv .= ' &middot; <a href="'.Href('qte_result_csv.php').'?'.GetURI('page,ok').'&amp;m=5&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(1-5000)</span></a> &middot; <a href="'.Href('qte_result_csv.php').'?'.GetURI('page,ok').'&amp;m=10&amp;n='.$intCount.'" class="tablecommand csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' <span class="small">(5000-10000)</span></a>';
  }
}
if ( !empty($strCsv) )
{
  $strPager = $strCsv.( $strPager==S || empty($strPager) ? '' : ' &middot; '.$strPager );
}

if ( $strPager )
{
echo '
<table class="hidden" cellspacing="0"><tr class="hidden"><td class="pager_zb">',$strPager,'</td></tr></table>
';
}

// MAP MODULE

if ( $bMap )
{
  echo '<!-- Map module -->',PHP_EOL;
  if ( count($arrExtData)>0 )
  {
    $strMapHelp = sprintf($L['map']['items'],strtolower(LangS('User',count($arrExtData))),strtolower(LangS('Result',$intCount)) );
    echo '<table class="hidden" style="margin-top:5px;">',PHP_EOL;
    echo '<tr class="hidden">',PHP_EOL;
    echo '<td class="gmap">',PHP_EOL;
    if ( !$_SESSION[QT]['m_map_hidelist'] )
    {
    echo QTgmapZoomControl($arrExtData);
    echo '<div id="map_canvas" style="width:100%; height:',($_SESSION[QT]['viewmode']=='C' ? '350' : '400'),'px;"></div>',PHP_EOL;
    }
    if ( !empty($strMapHelp) ) echo '<p class="gmap" style="margin:4px 0 0 0">'.$strMapHelp.'</span>';
    echo '</td>',PHP_EOL;
    echo '</tr>',PHP_EOL;
    echo '</table>',PHP_EOL;

    // Show/Hide

    if ( $_SESSION[QT]['m_map_hidelist'] )
    {
    echo '<p style="margin:2px"><a href="',Href(),'?s=',$s,'&amp;hidemap=0">',$L['map']['Show_map'],'</a></p>';
    }
    else
    {
    echo '<p style="margin:2px"><a href="',Href(),'?s=',$s,'&amp;hidemap=1">',$L['map']['Hide_map'],'</a></p>';
    }
  }
  else
  {
    echo '<p class="gmap">'.$L['map']['E_noposition'].'</p>',PHP_EOL;
  }
  echo '<!-- Map module end -->',PHP_EOL;
}

// --------
// HTML END
// --------

// MAP MODULE

if ( $bMap )
{
  if ( count($arrExtData)>0 )
  {
  if ( count($arrExtData)>1 && isset($_SESSION[QT]['m_map'][$s]['zoom']) ) $bZoomAll=($_SESSION[QT]['m_map'][$s]['zoom']=='1' ? true : false);
  include('qtem_map_load.php');
  }
  else
  {
  echo '<script type="text/javascript">function GUnload() { return true; }</script>';
  }
}

include('qte_p_footer.php');