<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
if ( !$oVIP->CanView('V3') ) die(Error(11));

// --------
// INITIALISE
// --------

$oVIP->selfurl = 'qte_search.php';
$oVIP->selfname = $L['Search'];

$s = -1;
if ( isset($_SESSION[QT]['section']) ) $s = intval($_SESSION[QT]['section']);
if ( isset($_GET['s']) ) $s = intval(strip_tags($_GET['s']));

// --------
// HTML START
// --------

$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="bin/css/qt_jquery.css" />';
$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript" src="bin/qt_jquery_auto.js"></script>
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length<2) { alert(qtHtmldecode("'.$L['E_min_2_char'].'")); return false; }
  return null;
}
$(document).ready(function() {
  $("#title").autocomplete("qte_j_index.php", {
    extraParams: {s: function(){return $("#sk").val();}},
    selectFirst: false,
    minChar:2,
    formatItem: function(value) { return value[0] + " (" + value[1] + ")"; },
    formatResult: function(value) { return value[0]; }
  });
  $("#sk").change(function() {
    $("#title").flushCache();
    });
});
-->
</script>';

include('qte_p_header.php');

// advanced search

if ( isset($_GET['a']) || isset($_GET['s']) || isset($_SESSION[QT]['section']) || isset($_GET['status']) || isset($_GET['role']) || isset($_GET['age']))
{
  if ( isset($_GET['status']) ) { $strStatus = strip_tags($_GET['status']); } else { $strStatus = null; }
  if ( isset($_GET['age_criteria']) ) { $strCriteria = strip_tags($_GET['age_criteria']); } else { $strCriteria = null; }
  
  echo '<h2>',$L['Search_by_key'],'</h2>',PHP_EOL;
  echo '<form method="get" action="',Href('qte_result.php'),'" onsubmit="return ValidateForm(this);">',PHP_EOL;
  echo '<table class="data_s" cellspacing="0">',PHP_EOL;  
  echo '<tr class="data_s">',PHP_EOL;
  echo '<td class="colhd colhdfirst colhdempty"></td>',PHP_EOL;
  echo '<td class="colhd colhdempty"></td>',PHP_EOL;
  echo '<td class="colhd colhdlast colhdempty"></td>',PHP_EOL;
  echo '</tr>',PHP_EOL;
  echo '<tr class="data_s">',PHP_EOL;
  echo '<td class="colct colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>',PHP_EOL;
  echo '<td class="colct">',PHP_EOL;
  echo '<input type="text" id="title" name="title" size="30" maxlength="32" value="',(isset($_GET['title']) ? $_GET['title'] : ''),'" /> ',
  $L['In_section'],'  
  <select id="sk" name="s" size="1">
  <option value="-1"',($s<0 ? QSEL : ''),'>('.$L['All'].')</option>',Sectionlist($s),'
  </select></td>
  <td class="colct colast" style="text-align:right; width:100px"><input type="submit" id="okref" name="ok" value="',$L['Search'],'"/>&nbsp;</td>
  </tr>
  <tr class="data_s">
  <td class="colft colftfirst"></td>
  <td class="colft"></td>
  <td class="colft colftlast"></td>
  </tr>
  </table>
  </form>
  ';
  echo '<h2>',$L['Search_by_status'],'</h2>',PHP_EOL;
  echo '<form method="get" action="',Href('qte_result.php'),'">',PHP_EOL;
  echo '<table class="data_s" cellspacing="0">',PHP_EOL;
  echo '<tr class="data_s">',PHP_EOL;
  echo '<td class="colhd colhdfirst colhdempty"></td>',PHP_EOL;
  echo '<td class="colhd colhdempty"></td>',PHP_EOL;
  echo '<td class="colhd colhdlast colhdempty"></td>',PHP_EOL;
  echo '</tr>',PHP_EOL;
  echo '<tr class="data_s">',PHP_EOL;
  echo '<td class="colct colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>',PHP_EOL;
  echo '<td class="colct">',PHP_EOL;
  echo $L['Status'],' <select id="status" name="status" size="1">',QTasTag($oVIP->statuses,$strStatus),'</select> ',
  $L['In_section'],' 
  <select id="s" name="s" size="1">
  <option value="-1"',($s<0 ? QSEL : ''),'>('.$L['All'].')</option>',Sectionlist($s),'
  </select></td>
  <td class="colct colast" style="text-align:right; width:100px"><input type="submit" name="ok" value="',$L['Search'],'"/>&nbsp;</td>
  </tr>
  <tr class="data_s">
  <td class="colft colftfirst"></td>
  <td class="colft"></td>
  <td class="colft colftlast"></td>
  </tr>
  </table>  
  </form>
  ';
  echo '<h2>',$L['Search_by_age'],'</h2>',PHP_EOL;
  echo '<form method="get" action="',Href('qte_result.php'),'">',PHP_EOL;
  echo '<table class="data_s" cellspacing="0">',PHP_EOL;
  echo '<tr class="data_s">',PHP_EOL;
  echo '<td class="colhd colhdfirst colhdempty"></td>',PHP_EOL;
  echo '<td class="colhd colhdempty"></td>',PHP_EOL;
  echo '<td class="colhd colhdlast colhdempty"></td>',PHP_EOL;
  echo '</tr>',PHP_EOL;
  echo '<tr class="data_s">',PHP_EOL;
  echo '<td class="colct colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>',PHP_EOL;
  echo '<td class="colct">',PHP_EOL;
  echo ObjTrans('field','age').' <select id="age_criteria" name="age_criteria" size="1">',QTasTag(array('l'=>'&lt;','u'=>'&gt;=','e'=>'='),$strCriteria),'</select> 
  <input type="text" id="age" name="age" size="2" maxlength="2" value="',(isset($_GET['age']) ? $_GET['age'] : 13),'" /> ',
  $L['In_section'],' 
  <select id="sa" name="s" size="1">
  <option value="-1"',($s<0 ? QSEL : ''),'>('.$L['All'].')</option>',Sectionlist($s),'
  </select></td>
  <td class="colct colast" style="text-align:right; width:100px"><input type="submit" id="okage" name="ok" value="',$L['Search'],'"/>&nbsp;</td>
  </tr>
  <tr class="data_s">
  <td class="colft colftfirst"></td>
  <td class="colft"></td>
  <td class="colft colftlast"></td>
  </tr>
  </table>  
  </form>
  <p style="text-align:right"><a href="',Href('qte_result.php'),'?role=A">',$L['Userroles']['A'],'</a> | <a href="',Href('qte_result.php'),'?role=M">',$L['Userroles']['M'],'</a></p>
  ';
}
else // simple search
{
  echo '<h2>',$L['Search_by_key'],'</h2>',PHP_EOL;
  echo '<form method="get" action="',Href('qte_result.php'),'" onsubmit="return ValidateForm(this);">',PHP_EOL;
  echo '<table class="data_s" cellspacing="0">',PHP_EOL;  
  echo '<tr class="data_s">',PHP_EOL;
  echo '<td class="colhd colhdfirst colhdempty"></td>',PHP_EOL;
  echo '<td class="colhd colhdempty"></td>',PHP_EOL;
  echo '<td class="colhd colhdlast colhdempty"></td>',PHP_EOL;
  echo '</tr>',PHP_EOL;
  echo '<tr class="data_s">',PHP_EOL;
  echo '<td class="colct colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>',PHP_EOL;
  echo '<td class="colct"><input type="text" id="title" name="title" size="30" maxlength="32" value="',(isset($_GET['title']) ? $_GET['title'] : ''),'" /> <input type="hidden" id="sk" name="sk" value="-1"/><input type="submit" id="ok" name="ok" value="',$L['Search'],'"/></td>
  <td class="colct colast" style="text-align:right"><a id="advanced" href="',Href(),'?a=1&amp;title=" onclick="document.getElementById(\'advanced\').href += document.getElementById(\'title\').value;">',$L['Advanced'],'...</a>&nbsp;</td>
  </tr>
  <tr class="data_s">
  <td class="colft colftfirst"></td>
  <td class="colft"></td>
  <td class="colft colftlast"></td>
  </tr>
  </table>
  </form>
  ';
}

// --------
// HTML END
// --------

echo '<script type="text/javascript">document.getElementById("title").focus();</script>';

include('qte_p_footer.php');