<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
if ( !$oVIP->CanView('U') ) die(Error(11));
$id = -1; QThttpvar('id','int'); if ( $id<0 ) die('Missing id...');

// --------
// INITIALISE
// --------

include('bin/qt_lib_smtp.php');
include(Translate('qte_reg.php'));

$oVIP->selfurl = 'qte_unregister.php';
$oVIP->selfname = $L['Unregister'];
$oVIP->exiturl = Href('qte_user.php').'?tt=s&amp;id='.$id;
$oVIP->exitname = '&laquo; '.$L['Profile'];

if ($id<2 ) $oVIP->EndMessage(NULL,$L['E_access'].'<br />Visitor and System administrator cannot be deleted.',$_SESSION[QT]['skin_dir'],0);;
if ($oVIP->id!=$id ) $oVIP->EndMessage(NULL,$L['E_access'].'<br />Only user himself can unregister. System coordinator can delete users.',$_SESSION[QT]['skin_dir'],0);

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check password
  $oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE id='.$id.' AND pwd="'.sha1($_POST['title']).'"');
  $row = $oDB->Getrow();
  if ($row['countid']==0) $error=$L['Password'].' '.$L['E_invalid'];

  // execute and exit
  if ( empty($error) )
  {
    $oDB->Query('SELECT * FROM '.TABUSER.' WHERE id='.$id);
    $row = $oDB->Getrow();
    $oUser = new cUser($row);
    $oUser->Delete(true); // delete and update stats in all sections
    
    $oVIP->exiturl = Href('qte_login.php').'?a=out';
    $oVIP->EndMessage(NULL,$L['S_delete'],$_SESSION[QT]['skin_dir'],2);
  }
}

// --------
// HTML START
// --------

$oUser = new cUser($id);

$strHeadScript = '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("'.$L['Missing'].': '.$L['Password'].'")); return false; }
  return null;
}
-->
</script>
';

include('qte_p_header.php');

echo '
<table class="hidden" cellspacing="0">
<tr class="hidden">
<td class="hidden" style="width:175px;"><br />',AsImgBoxUser($oUser,'username'),'</td>
<td class="hidden">
';

$oHtml->Msgbox($oVIP->selfname);

$str = $L['H_Unregister'].'
<form method="post" action="'.Href().'" onsubmit="return ValidateForm(this);">
<input type="hidden" name="id" value="'.$id.'" />
<p>'.$L['Password'].' <input type="password" id="title" name="title" size="20" maxlength="32" /> <input type="submit" name="ok" value="'.$L['Ok'].'" /> <span id="title_err" class="error"></span></p>
</form>
';
if ( $oUser->role!='U' ) $str = '<p>'.$oUser->username.' is a Staff member.<br />To unregister a staff member, an administrator must first change role to User, or use the delete function.</p>';
if ( $id<2 ) $str = '<p>Admin and Visitor cannot be removed...</p>';

if ( !empty($error) ) echo '<p id="infomessage" class="error">',$error,'</p>';
echo '<h2>',$oUser->fullname,'</h2>
<p class="bold">username: ',$oUser->fullname,'</p>
',$str,'
<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>
';

$oHtml->Msgbox();

echo '
</td>
</tr>
</table>
';

// --------
// HTML END
// --------

$strFooterAddScript = '
<script type="text/javascript">
<!--
document.getElementById("title").focus();
-->
</script>
';

include('qte_p_footer.php');