<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Team
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110418
 */

session_start();
require_once('bin/qte_init.php');
if ( $_SESSION[QT]['picture']=='0' ) die(Error(10));
if ( !$oVIP->CanView('U') ) die(Error(11));
$id = -1; QThttpvar('id','int'); if ( $id<0 ) die('Missing parameter id...');
if ( $oVIP->role!='A' ) { if ($oVIP->id!=$id) die($L['R_user']); }

// --------
// INITIALISE
// --------

include(Translate('qte_reg.php'));

if ( !isset($_SESSION['temp_key']) ) $_SESSION['temp_key']= "";
if ( !isset($_SESSION['temp_ext']) ) $_SESSION['temp_ext']= "";

$oVIP->selfurl = 'qte_user_img.php';
$oVIP->selfname = $L['Change_picture'];
$oVIP->exiturl = Href('qte_user.php').'?id='.$id.'&amp;tt=s';
$oVIP->exitname = $L['Profile'];

$upload_path = QTE_DIR_PIC.TargetDir(QTE_DIR_PIC,$id); // The path to where the image will be saved
$large_image_location = $upload_path.'src'.$id.'_'.$_SESSION['temp_key'].$_SESSION['temp_ext'];
$thumb_image_location = $upload_path.$id.$_SESSION['temp_ext'];

// Save and notify (if coppa)
function saveThumbnail($id,$str)
{
  global $oDB; $oDB->Query('UPDATE '.TABUSER.' SET picture="'.$str.'" WHERE id='.$id);

  if ( $_SESSION[QT]['register_coppa']=='1' )
  {
    global $oUser;
    if ( $oUser->coppa!=0 )
    {
    include('bin/qt_lib_smtp.php');
    $strSubject = $_SESSION[QT]['site_name'].' - New picture';
    $strMessage = "We inform you that your children (%s) has changed his/her picture on the board {$_SESSION[QT]['site_name']}.";
    $strFile = GetLang().'mail_img_coppa.php';
    if ( file_exists($strFile) ) include($strFile);
    $strMessage = sprintf($strMessage,$_POST['name']);
    QTmail($oUser->parentmail,QTconv($strSubject,'-4'),QTconv($strMessage,'-4'),QTE_HTML_CHAR);
    }
  }
}

// --------
// SUBMITTED for Exit
// --------

if ( isset($_POST['exit']) )
{
  if ( file_exists($large_image_location) ) unlink($large_image_location);
  unset($_SESSION['temp_key']);
  $oHtml->Redirect($oVIP->exiturl);
}

// --------
// INITIALISE image and repository object
// --------

$oUser = new cUser($id);

$photo = (empty($oUser->picture) ? '' : $oUser->picture); // Current photo (Can be empty)
$photolabel = $oUser->firstname.'<br />'.$oUser->lastname;

$max_file = 3;           // Maximum file size in MB
$max_width = 650;        // Max width allowed for the large image
$thumb_max_width = 150;  // Above this value, the crop tool will start
$thumb_max_height = 150; // Above this value, the crop tool will start
$thumb_width = 100;      // Width of thumbnail image
$thumb_height = 100;     // Height of thumbnail image
$strMimetypes = 'image/pjpeg,image/jpeg,image/jpg';
if ( strpos($_SESSION[QT]['picture'],'gif')!==FALSE) $strMimetypes.=',image/gif';
if ( strpos($_SESSION[QT]['picture'],'png')!==FALSE) $strMimetypes.=',image/png,image/x-png';

//Check to see if any images with the same name already exist
$large_photo_exists = ''; if ( file_exists($large_image_location) ) $large_photo_exists = "<img src=\"".$large_image_location."\" alt=\"Large Image\"/>";

// --------
// SUBMITTED for Delete
// --------

if ( isset($_POST['del']) )
{
  if ( file_exists($large_image_location) ) unlink($large_image_location);
  if ( file_exists($oUser->picture) ) unlink($oUser->picture);
  $oDB->Query('UPDATE '.TABUSER.' SET picture="0" WHERE id='.$id);
  unset($_SESSION['temp_key']);
  $oVIP->EndMessage(NULL,$L['S_delete'],$_SESSION[QT]['skin_dir'],2);
}

// --------
// PAGE
// --------

include('qte_upload_img.php');