<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110323
 */

session_start();
require_once('bin/qte_init.php');
if ( !$oVIP->CanView('U') ) die(Error(11));
$id = -1; QThttpvar('id','int'); if ($id<0) die('Missing parameters');

// --------
// INITIALISE
// --------

include('bin/qt_lib_smtp.php');
include(Translate('qte_reg.php'));

$oVIP->selfurl = 'qte_user_rename.php';
$oVIP->selfname = $L['Change_name'];
$oVIP->exiturl = Href('qte_user.php').'?tt=s&amp;id='.$id;
$oVIP->exitname = '&laquo; '.$L['Profile'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check name
  if ( empty($error) )
  {
    $strName = trim(strip_tags($_POST['title'])); if ( get_magic_quotes_gpc() ) $strName = stripslashes($strName);
    if ( !QTislogin($strName) ) $error = $L['E_invalid'];
    if ( empty($error) )
    {
    $oDB->Query('SELECT count(*) as countid FROM '.TABUSER.' WHERE username="'.$strName.'"');
    $row = $oDB->Getrow();
    if ( $row['countid']!=0 ) $error = $L['E_already_used'];
    }
  }

  // execute and exit
  if ( empty($error) )
  {
    $oDB->Query('UPDATE '.TABUSER.' SET username="'.$strName.'" WHERE id='.$id);
    // index
    $oDB->query('DELETE FROM '.TABINDEX.' WHERE userid='.$id.' AND ufield="username"');
    $oDB->query('INSERT INTO '.TABINDEX.' (userid,ufield,ukey) VALUES ('.$id.',"username","'.$strName.'")');

    $oVIP->exiturl = Href('qte_login.php').'?dfltname='.$strName;
    $oVIP->exitname = '&laquo; '.$L['Login'];
    $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  }
}

// --------
// HTML START
// --------

$oUser = new cUser($id);

$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("'.$L['Missing'].': '.$L['Username'].'")); return false; }
  return null;
}
$(function() {
  $("#title").keyup(function() {
    if ($("#title").val().length>1)
    {
      $.post("qte_j_exists.php",
      {f:"username",v:$("#title").val(),e1:"'.$L['E_min_4_char'].'",e2:"'.$L['E_already_used'].'"},
      function(data) { if ( data.length>0 ) document.getElementById("title_err").innerHTML=data; });
    }
    else
    {
      document.getElementById("title_err").innerHTML="";
    }
  });
});
-->
</script>
';

include('qte_p_header.php');

if ( !empty($error) ) echo '<p id="infomessage" class="error">',$error,'</p>';

echo '<table class="hidden" cellspacing="0">',PHP_EOL;
echo '<tr class="hidden">',PHP_EOL;
echo '<td class="hidden" style="width:180px;"><br/>',AsImgBoxUser($oUser,'status');
if ( $oVIP->id!=$id ) echo '<div class="profile warning"><p class="profile warning">',$L['W_Somebody_else'],'</p></div>';
echo '</td>',PHP_EOL;
echo '<td class="hidden">',PHP_EOL;

$oHtml->Msgbox($oVIP->selfname);

echo '<form method="post" action="',Href(),'" onsubmit="return ValidateForm(this);">
<input type="hidden" name="id" value="',$id,'" />
<h2>',$oUser->username,'</h2>
<p>',$L['Choose_name'],'</p>
<p><input type="text" id="title" name="title" size="20" maxlength="32" onfocus="document.getElementById(\'title_err\').innerHTML=\'\';" /> <input type="submit" name="ok" value="',$L['Save'],'" /> <span id="title_err" class="error"></span></p>
</form>
<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>
';

$oHtml->Msgbox();

echo '
</td>
</tr>
</table>
';

// --------
// HTML END
// --------

include('qte_p_footer.php');